/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDStd.h  :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CDEVICEDSTD_H)
    #define  CDEVICEDSTD_H

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

/*The following definition is the version.*/
#define CDEVDSTD_OBJECT_VERSION 100

#define CDEVDSTD_MODELNAME_SIZE 32
#define CDEVDSTD_SERIALNUMBER_SIZE 16
#define CDEVDSTD_DEVICEGUID_SIZE 16

typedef  enum CDEVDSTDtypSPECIES {
    CDEVDSTD_SpSTANDARD = 0,
    CDEVDSTD_SpMAX
} CDEVDSTD_SPECIES;

#define CDEVDSTD_STATIC_DATA_SIZE (MOIB_TIME_SIZE + SIZEOF(uint32) +\
                                   CDEVDSTD_MODELNAME_SIZE + \
                                   CDEVDSTD_SERIALNUMBER_SIZE + \
                                   CDEVDSTD_DEVICEGUID_SIZE)
typedef struct CDeviceDStd
{
    /*DtData members*/
    uint32    ClassID;
    boolean   DirtyFlag;

    /*Static Data*/
    MOIB_TIME     m_DateTime;
    uint32        m_RunTime;
    ansichar      m_ModelName[CDEVDSTD_MODELNAME_SIZE/2];
    ansichar      m_SerialNumber[CDEVDSTD_SERIALNUMBER_SIZE/2];
    uint8         m_DeviceGUID[CDEVDSTD_DEVICEGUID_SIZE/2];
}CDeviceDStd;

void    CDeviceDStd_Init(CDeviceDStd *new);
uint32  CDeviceDStd_GetPayloadSize(CDeviceDStd *pObject);
uint32  CDeviceDStd_SizeAll(CDeviceDStd *pObject);
boolean CDeviceDStd_Deserialize(CDeviceDStd *pObject, uint8 *pBuf);
boolean CDeviceDStd_Serialize(CDeviceDStd *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CDeviceDStd();
#endif

#endif /* #if !defined(CDEVICEDSTD_H) */

