/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrSvr.h      :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   WACP                                           //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined __CErrSvrH_C
    #define  __CErrSvrH_C

#include "DtSupport.h"
#include "StdVarTyp.h"
#include "Mem.h"
#include "string.h"

typedef  enum CEStypSPECIES {
    CES_SpNONE = 0,
    CES_SpERROR,
    CES_SpMAX
} CES_SPECIES;

#define CES_STATIC_STRUCT_SIZE (SIZEOF(uint32))

typedef struct CErrSvr
{
    /* DtData static members */
    uint32      ClassID;

    /* CErrSvr static members */
    uint32      ErrorClassID;

    /*Dynamic Data*/
    uint8       Data[MAX_DATA_MEMBER_SIZE];
    uint32      DataSize;
}CErrSvr;

void    CErrSvr_Init(CErrSvr *new, uint8 Genus);
uint32  CErrSvr_SizeAll(CErrSvr *pObject);
boolean CErrSvr_Deserialize(CErrSvr *pObject, uint8* pBuf);
boolean CErrSvr_Serialize(CErrSvr *pObject, uint8 *pBuf);

#endif /*__CErrSvrH_C*/
