/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CError.h       :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined __CErrorH_C
    #define  __CErrorH_C

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"
#include <string.h>

/*The following definition is the version.*/
#define CERR_OBJECT_VERSION 100
#define CERR_DESC_SIZE      20
/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
typedef  enum CERRtypSPECIES {
    CERR_SpNONE = 0,
    CERR_SpWACPSTACK,
    CERR_SpAPPINTERNAL,
    CERR_SpMAX
} CERR_SPECIES;

typedef enum CERRtypERROR {
    CERR_NONE = 0,
    CERR_UNIMPL,
    CERR_INVL_FAMILY,
    CERR_INVL_GENUS,
    CERR_INVL_SPECIES,
    CERR_OBJECT_ID,
    CERR_CRC_MISMATCH,  
    CERR_MEMORY,
    CERR_INVL_TBL_ENTRY,
    CERR_DUP_ENTRY,
    CERR_MAX
} CERR_LIST;

/* Add Code here for AppInternal Errors */
typedef enum CERRtypAPPERROR {
    CERR_APP_NONE = 0,
    CERR_APP_CMD_FAILED,
    CERR_APP_MAX
} CERR_APPLIST;

/*---------------------------------------------------*/

#define CERR_STATIC_DATA_SIZE (SIZEOF(uint32) + SIZEOF(uint16) + CERR_DESC_SIZE)
#define CERR_MAX_DATA_SIZE 16

typedef struct CError
{   
    /* Static DtData members */
    uint32      ClassID;

    /* Static Data */
    uint32      ErrorClassID;
    uint16      ErrorCode;
    ansichar    Description[CERR_DESC_SIZE];

    /* Dynamic Data */
    uint8       Data[CERR_MAX_DATA_SIZE];
    uint32      DataSize;
}CError;

void    CError_Init(CError *new, uint8 Species);
uint32  CError_GetPayloadSize(CError *pObject);
uint32  CError_SizeAll(CError *pObject);
boolean CError_Deserialize(CError *pObject, uint8* pBuf);
boolean CError_Serialize(CError *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CError();
#endif


#endif /*__CErrorH_C*/
