/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashCfgDevice.h  :                                              //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CFLASHCFGDEVICE_H)
    #define  CFLASHCFGDEVICE_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"


typedef  enum CFLSCDEVtypSPECIES {
    CFLSCDEV_SpDEVICEFLASHCFG = 1,
    CFLSCDEV_SpMAX
} CFLSCDEV_SPECIES;


/*The following definition is the version.*/
#define CFLSCDEV_OBJECT_VERSION 100

#define CFLSCDEV_STATIC_DATA_SIZE (2*SIZEOF(byte)+SIZEOF(uint32))

typedef struct CFlashCfgDevice
{
    /* DtData members */
    uint32      ClassID;
    boolean     DirtyFlag;

    /*Static Data*/
    uint32      m_FlashSize;
    byte        m_WordSize;
    byte        m_Sectors;
}CFlashCfgDevice;

void    CFlashCfgDevice_Init(CFlashCfgDevice *new);
uint32  CFlashCfgDevice_GetPayloadSize(CFlashCfgDevice *pObject);
uint32  CFlashCfgDevice_SizeAll(CFlashCfgDevice *pObject);
boolean CFlashCfgDevice_Deserialize(CFlashCfgDevice *pObject, uint8 *pBuf);
boolean CFlashCfgDevice_Serialize(CFlashCfgDevice *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CFlashCfgDevice();
#endif

#endif /* #if !defined(CFLASHCFGDEVICE_H) */


