/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashDSectorCRC.h  :                                             //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CFLASHDSECTORCRC_H)
    #define  CFLASHDSECTORCRC_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"

typedef  enum CFLSDCRCtypSPECIES {
    CFLSDCRC_SpFLASHCRC = 1,
    CFLSDCRC_SpMAX
} CFLSDCRC_SPECIES;

/*The following definition is the version.*/
#define CFLSDCRC_OBJECT_VERSION 100

#define CFLSDCRC_STATIC_DATA_SIZE (SIZEOF(byte)+SIZEOF(uint16))

typedef struct CFlashDSectorCRC
{
    /* DtData members */
    uint32      ClassID;
    boolean     DirtyFlag;
    
    /* Static Data */
    byte        m_Sector;
    uint16      m_CRC;
}CFlashDSectorCRC;

void    CFlashDSectorCRC_Init(CFlashDSectorCRC *new);
uint32  CFlashDSectorCRC_GetPayloadSize( CFlashDSectorCRC *pObject );
uint32  CFlashDSectorCRC_SizeAll( CFlashDSectorCRC *pObject );
boolean CFlashDSectorCRC_Deserialize(CFlashDSectorCRC *pObject, uint8 *pBuf );
boolean CFlashDSectorCRC_Serialize(CFlashDSectorCRC *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CFlashDSectorCRC();
#endif

#endif /* #if !defined(CFLASHDSECTORCRC_H) */


