/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashDSegment.h  :                                               //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CFLASHDSEGMENT_H)
    #define  CFLASHDSEGMENT_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "Mem.h"


typedef  enum CFLSDSEGtypSPECIES {
    CFLSDSEG_SpFLASHSEG = 0,
    CFLSDSEG_SpMAX
} CFLSDSEG_SPECIES;

/*The following definition is the version.*/
#define CFLSDSEG_OBJECT_VERSION 100

#define CFLSDSEG_STATIC_DATA_SIZE (SIZEOF(byte)+2*SIZEOF(uint32))

typedef struct CFlashDSegment
{
    /* DtData Members */
    uint32      ClassID;
    boolean     DirtyFlag;

    /*Static Data*/
    byte        m_Sector;
    uint32      m_SegmentSize;
    uint32      m_Start;

    /*Dynamic Data*/
    uint8   	m_Contents[MAX_DATA_MEMBER_SIZE];
    uint16      m_ContentsSize;
}CFlashDSegment;

void    CFlashDSegment_Init(CFlashDSegment *new);
uint32  CFlashDSegment_GetPayloadSize(CFlashDSegment *pObject);
uint32  CFlashDSegment_SizeAll(CFlashDSegment *pObject);
boolean CFlashDSegment_Deserialize(CFlashDSegment *pObject, uint8 *pBuf);
boolean CFlashDSegment_Serialize(CFlashDSegment *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CFlashDSegment();
#endif

#endif /* #if !defined(CFLASHDSEGMENT_H) */


