/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CMsgSvr.h      :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined __CMSGSVRH_C
    #define  __CMSGSVRH_C

#include "StdVarTyp.h"
#include "Mem.h"

#define CMSG_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
typedef  enum CMSGtypSPECIES {
    CMSG_SpNONE = 0,
    CMSG_SpMAX
}CMSG_SPECIES;

typedef struct CMsgSvr
{
    /* Static Data */
    uint32      ClassID;

    /*Dynamic Data*/
    uint8       Data[MAX_DATA_MEMBER_SIZE];
    uint32      DataSize;
}CMsgSvr;

void    CMsgSvr_Init(CMsgSvr *new, uint16 Family, uint8 Genus, uint8 Species);
uint32  CMsgSvr_SizeAll ( CMsgSvr *pObject );
boolean CMsgSvr_Deserialize (CMsgSvr *pObject, uint8* pBuf);
boolean CMsgSvr_Serialize (CMsgSvr *pObject, uint8 *pBuf);

#endif /*__CMSGSVRH_C*/



