/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRNDZApp.h     :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined __CRNDZAPPH
    #define  __CRNDZAPPH

#include <stdio.h>
#include "StdVarTyp.h"
#include "Common.h"
#include "DtSupport.h"
#include "Wacp.h"

typedef  enum RNDZCCMDtypSPECIES {
    RNDZ_CCMD_SpNONE = 0,
    RNDZ_CCMD_SpTERMINATE,
    RNDZ_CCMD_SpSTART_HOST_PROC,
    RNDZ_CCMD_SpSEND_HOST_READY,
    RNDZ_CCMD_SpMAX
} RNDZ_CCMD_SPECIES;

typedef  enum RNDZCRSTtypSPECIES {
    RNDZ_CRST_SpNONE = 0,
    RNDZ_CRST_SpSTART_RNDZ,
    RNDZ_CRST_SpGET_ENCRYPT_KEY,
    RNDZ_CRST_SpMAX
} RNDZ_CRST_SPECIES;

typedef  enum RNDZCRSPtypSPECIES {
    RNDZ_CRSP_SpNONE = 0,
    RNDZ_CRSP_SpRNDZ_ACCEPT,
    RNDZ_CRSP_SpSEND_ENCRYPT_KEY,
    RNDZ_CRSP_SpHOST_READY,
    RNDZ_CRSP_SpMAX
} RNDZ_CRSP_SPECIES;

#define TERMINATE_RNDZ_APP  "EXIT_RNDZ"
#define RNDZ_CONNECT_SIZE   11
#define RNDZ_CONNECT_MSG    "RNDZCONNECT"
#define RNDZ_WAIT_TIME      100
#define RNDZ_TIMEOUT		20 				/* equivalent to 20 * RNDZ_WAIT_TIME */

void CRNDZApp_Terminate(boolean bStatus);
boolean CRNDZApp_AppStart();
boolean CRNDZApp_InitClient();
boolean CRNDZApp_RxMsg(uint8 Genus, uint8 MsgID, uint8 *pBuf);


#endif //__CRNDZAPPH
//---------------------------------------------------
