/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWaveSampleCRPDetect.h:                                           //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined (CWAVESAMPLECRPDETECT_H)
    #define  CWAVESAMPLECRPDETECT_H

#include "StdVarTyp.h"
#include "Mem.h"
#include "DtSupport.h"

#define CWVSCRPD_OBJECT_VERSION 100

typedef  enum CWVSCRPDtypSPECIES {
    CWVSCRPD_SpRWAVDETCFG = 128,
    CWVSCRPD_SpPWAVDETCFG = 129,
    CWVSCRPD_SpMAX
} CWVSCRPD_SPECIES;

#define CWVSCRPD_STATIC_DATA_SIZE (SIZEOF(byte) + SIZEOF(boolean))

typedef struct CWaveSampleCRPDetect
{
    /* DtData static members */
    uint32      ClassID;
    boolean     DirtyFlag;
    
    /* CWaveSampleCStd static members */
    boolean     m_IsActive;
    byte        m_DetectChannel;

}CWaveSampleCRPDetect;

void    CWaveSampleCRPDetect_Init(CWaveSampleCRPDetect *new);
uint32  CWaveSampleCRPDetect_GetPayloadSize( CWaveSampleCRPDetect *pObject);
uint32  CWaveSampleCRPDetect_SizeAll(CWaveSampleCRPDetect *pObject);
boolean CWaveSampleCRPDetect_Deserialize(CWaveSampleCRPDetect *pObject, uint8* pBuf);
boolean CWaveSampleCRPDetect_Serialize(CWaveSampleCRPDetect *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CWaveSampleCRPDetect();
#endif

#endif /* #if !defined(CWAVESAMPLECRPDETECT_H) */



