/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWaveSampleCStd.h:                                                //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   DTP                                            //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined (CWAVESAMPLECSTD_H)
    #define  CWAVESAMPLECSTD_H

#include "StdVarTyp.h"
#include "Mem.h"
#include "DtSupport.h"

#define CWVSCSTD_OBJECT_VERSION 100

typedef  enum CWVSCSTDtypSPECIES {
    CWVSCSTD_SpSTANDARD = 0,
    CWVSCSTD_SpECGWAVCFG,
    CWVSCSTD_SpAUDIOWAVCFG,
    CWVSCSTD_SpECGLEADFAILWAVCFG,
    CWVSCSTD_SpSPIROWAVECFG,
    CWVSCSTD_SpMAX
} CWVSCSTD_SPECIES;

#define CWVSCSTD_STATIC_DATA_SIZE\
        2 *(SIZEOF(int16)) + 2 *(SIZEOF(byte)) + 1 *(SIZEOF(boolean))

typedef struct CWaveSampleCStd
{
    /* DtData static members */
    uint32      ClassID;
    boolean     DirtyFlag;

    /* CWaveSampleCStd static members */
    boolean     m_IsActive;
    int16       m_SampleFrequency;
    byte        m_SampleSize;
    int16       m_SampleCount;
    byte        m_Channels;
}CWaveSampleCStd;

void    CWaveSampleCStd_Init(CWaveSampleCStd *new, uint8 Species);
uint32  CWaveSampleCStd_GetPayloadSize(CWaveSampleCStd *pObject);
uint32  CWaveSampleCStd_SizeAll(CWaveSampleCStd *pObject);
boolean CWaveSampleCStd_Deserialize(CWaveSampleCStd *pObject, uint8* pBuf);
boolean CWaveSampleCStd_Serialize(CWaveSampleCStd *pObject, uint8 *pBuf);

#if defined(COOA_OBJECT_TEST)
boolean Test_CWaveSampleCStd();
#endif

#endif /* #if !defined(CWAVESAMPLECSTD_H) */



