/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Mem.h          :                                                  //
'**  '// version        :   1.0                                            //
'**  '// Language       :   C                                              //
'**  '// Development    :   Windows 2000 PentiumIII 500Mhz                 //
'**  '// Application    :   WACP                                           //
'**  '// Authors        :   Welch Allyn Inc. MedR&D                        //
'**  '// Sources        :   COOA                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(MEM_H)
    #define  MEM_H
#include "StdVarTyp.h"

#define HIGH_BYTE_MASK  0xFF00
#define LOW_BYTE_MASK   0x00FF

#define CRC_SEED    0xFFFF

uint8 ReadInt8(uint8** ppBuf, boolean *ByteAligned);
uint16 ReadInt16(uint8** ppBuf, boolean *ByteAligned);
uint32 ReadInt32(uint8** ppBuf, boolean *ByteAligned);
void WriteInt8(uint8** ppBuf, uint8 Val, boolean *ByteAligned);
void WriteInt16(uint8** ppBuf, uint16 Val, boolean *ByteAligned);
void WriteInt32(uint8** ppBuf, uint32 Val, boolean *ByteAligned);

uint16 CalculateCRC(uint16 CurrentCRC, uint8 *pBuf, uint32 BufSize, boolean ByteAligned);

#endif  /* #if !defined(MEM_H) */
