/*-D*************************************************************************
 *   This program source file is confidential and proprietary property of
 *    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
 *                         Copyright (c) 2004 by
 *                              Welch Allyn Inc.
 *                            All rights reserved
 ****************************************************************************
 ****************************************************************************
 **
 **     A standard header file for use in all Welch Allyn Medical Division
 **     software development involving the C/C++ programming language.
 **
 ****************************************************************************
 **  ////////////////////////////////////////////////////////////////////////
 **  // Target.h    :                                                      //
 **  // version     :   0.0                                                //
 **  // Language    :   C/C++                                              //
 **  // Platform    :   Embedded and host/PC                               //
 **  // Development :                                                      //
 **  // Application :   DTP                                                //
 **  // Authors     :   Welch Allyn Inc. MedR&D                            //
 **  //                                                                    //
 **  // Sources     :                                                      //
 **  ////////////////////////////////////////////////////////////////////////
 ****************************************************************************
 *-E************************************************************************/
#if !defined(TARGET_H)
#define TARGET_H


/*
 * Simple macro to make compiler happy when function arguments are not used.
 */
#define TOUCH(X)    (X=X)

/*
 * Note: enums don't seem to work for #if conditional testing under VC++
 */

/*
 * Target Processor Types
 */

#define CPU_C5000       7   /* Texas Instrument C5000 DSP */


/* 
 * Stack Type
 */
/*  #define STACK_ETHERNET 1 */
#define STACK_SERIAL 1

#ifdef STACK_SERIAL
    /* Select a RS232 Connection type */
    //#define STACK_SERIAL_DTR   1 
    //#define STACK_SERIAL_HOST   1 
#endif /* STACK_SERIAL */

/*
 * Processor endian Types
 */
#define LITTLE_ENDIAN   0  /* Intel, et. al. */
#define BIG_ENDIAN      1


/*
 * Endianness of date stream on the media.
 */
#define MEDIA_ENDIANNES         BIG_ENDIAN


/******************************************/
/* Target Processor Dependent Definitions */
/******************************************/


/************************************************************************
  __TARGET_CPU_C5000 C Compiler
*************************************************************************/
#define TARGET_CPU              CPU_C5000
#define TARGET_ENDIANNESS       BIG_ENDIAN   /* Check compiler output */
#define MAX_DATA_MEMBER_SIZE    ( 150 )

//#define PC
//#define COOA_OBJECT_TEST 1
//#define DEBUG_PRINT_STATUS 1
//#define TEST_DEBUG 1

#endif  /* #if !defined (STDVARTYP_H) */

/* End of File */


