// Copyright in this code is held by Dr B. R. Gladman but free direct or
// derivative use is permitted subject to acknowledgement of its origin.
// There are no guarantees of correctness or fitness for purpose.
// Dr B. R. Gladman <brg@gladman.me.uk>
#if !defined(AES_H)
    #define  AES_H

#include "Target.h"
#if defined(ENCRYPTION_ON)

#include <stdio.h>
#include "StdVarTyp.h"
#include "target.h"


#define n_row  4 // the number or rows in the state
#define n_col  4 // the number or columns in the state
#define n_maxr 14 // the maximum number of cipher rounds

typedef unsigned char aes_elem; // a finite field element in GF(256)
typedef aes_elem aes_col[n_row]; // a column of four GF(256) elements
typedef aes_col aes_state[n_col];// an array of columns for the state

typedef struct AESCrypt
{
    aes_state key_sch[n_maxr + 1]; /* the key schedule */
    int key_len;
}AESCrypt;

void AESCrypt_Init(AESCrypt *pObject);
void AESCrypt_Destroy(AESCrypt *pObject);

boolean AESCrypt_key(AESCrypt *pObject, unsigned char *key, int keylen);
boolean AESCrypt_encrypt(AESCrypt *pObject, unsigned char *pt, unsigned char *ct);
boolean AESCrypt_decrypt(AESCrypt *pObject, unsigned char *ct, unsigned char *pt);

#endif /* #if defined(ENCRYPTION_ON) */

#endif /* #if !defined(AES_H) */


