/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrSvr.h      :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(CERRSVR_H)
    #define  CERRSVR_H

#include "DtSupport.h"
#include "StdVarTyp.h"
#include "Mem.h"
#include "string.h"
#include "Common.h"

typedef  enum CEStypSPECIES {
    CES_SpNONE = 0,
    CES_SpWACPSTACK,
    CES_SpERRMSGPROC,
    CES_SpERRAPPINTERNAL,
    CES_SpMAX
} CES_SPECIES;

#define CES_HEADER_SIZE (sizeof(uint32) + sizeof(uint16))
#define CES_STATIC_STRUCT_SIZE (sizeof(uint32))

typedef struct CErrSvr
{
    /* DtData static members */
    uint32      ClassID;

    /* CErrSvr static members */
    uint32      ErrorClassID;

    /*Dynamic Data*/
    uint8       *Data;
    uint32      DataSize;
}CErrSvr;

void    CErrSvr_Init(CErrSvr *pObject, uint8 Genus);
uint32  CErrSvr_SizeAll(const CErrSvr *pObject);
boolean CErrSvr_Serialize(const CErrSvr *pObject, uint8 *pBuf);
boolean CErrSvr_Deserialize(CErrSvr *pObject, uint8* pBuf);

#endif /* #if !defined(CERRSVR_H) */
