/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CTrapObjSvr.h  :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#if !defined(CTRAPOBJSVR_H)
    #define  CTRAPOBJSVR_H

#include "CErrEStd.h"
#include "CErrSvr.h"
#include "CMsgSvr.h"
#include "Common.h"
#include "Wacp.h"
#include "Interchange.h"

typedef  enum TRAPCRSPtypSPECIES {
    TRAP_CRSP_SpNONE = 0,
    TRAP_CRSP_SpPUT_LASTERROR,
    TRAP_CRSP_SpMAX
}CRSP_SPECIES;

typedef  enum TRAPCRSttypSPECIES {
    TRAP_CRST_SpNONE = 0,
    TRAP_CRST_SpGET_LASTERROR,
    TRAP_CRST_SpMAX
}CRST_SPECIES;

typedef struct CTrapObjSvr
{
    CErrEStd   TrapErrObj;
    CErrSvr    TrapInErrSvr;
    CErrSvr    TrapOutErrSvr;
    CMsgSvr    TrapMsgSvr;
    CWACPMutex ErrorMutex;
}CTrapObjSvr;

/* Constructor / Destructor */
void CTrapObjSvr_Init(CTrapObjSvr *pObject);
void CTrapObjSvr_Destroy(CTrapObjSvr *pObject);

/*================================================================================
CTrapObjSvr Transmit Error Message
================================================================================*/
boolean CTrapObjSvr_TxError(CTrapObjSvr *pObject, const char *pSourceID, uint32 ClassID, 
                            uint8 ErrorSpecies, uint8* pBuf, uint32 Size);
boolean CTrapObjSvr_TxErrMsg(const char *pSourceID, const CErrSvr *pCErrSvr);

/*================================================================================
CTrapObjSvr Error Routing  
================================================================================*/
boolean CTrapObjSvr_SendError(CTrapObjSvr *pObject, const char *pSourceID, uint32 ClassID, 
                              uint16 ErrorCode, boolean bNotify);
boolean CTrapObjSvr_RecvMsgHandler (CTrapObjSvr *pObject, const char *pSourceID, uint8 *pBuf);

#endif /* #if !defined(CTRAPOBJSVR_H) */




