/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPMutex.c   :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#include "CWACPMutex.h"

void CWACPMutex_Init(CWACPMutex *pObject, const char *pName)
{
    pObject->hHandle = CreateMutex(NULL, FALSE, pName);
}

void CWACPMutex_Destroy(CWACPMutex *pObject)
{
    CloseHandle(pObject->hHandle);
}

uint32 CWACPMutex_Lock(const CWACPMutex *pObject, uint32 Timeout)
{
    uint32 MutexResult;

    MutexResult = WaitForSingleObject(pObject->hHandle, Timeout);

    return(MutexResult);
}

boolean CWACPMutex_Release(const CWACPMutex *pObject)
{
    boolean Result;

    Result = (boolean)ReleaseMutex(pObject->hHandle);

    return(Result);
}




