/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPQueue.h   :                                                  //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CWACPQUEUE_H)
    #define  CWACPQUEUE_H

#include "StdVarTyp.h"
#include "Common.h"
#include "CWACPMutex.h"

typedef struct QPACKET
{
    char        *pSourceID;
    uint8       *pDataBuf;
    uint32      DataSize;
}QPACKET;

typedef struct CWACPQueue
{
    QPACKET  **pDataQueue;
    uint32   Head;
    uint32   Tail;
    uint16   Count;
    uint32   MaxSize;
    CWACPMutex QueueMutex;
}CWACPQueue;

boolean CWACPQueue_Init(CWACPQueue *pObject, uint32 QueueSize);
boolean CWACPQueue_Destroy(CWACPQueue *pObject);
boolean CWACPQueue_Enqueue(CWACPQueue *pObject, char *pSourceID, uint8 *pDataBuf, uint32 DataSize);
QPACKET *CWACPQueue_Dequeue(CWACPQueue *pObject);

#endif /* #if !defined(CWACPQUEUE_H) */

/*---------------------------------------------------*/
/* End of File */
