/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'*                         Copyright (c) 2004-2005 by
'*                              Welch Allyn Inc.
'*                            All rights reserved
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPSemaphore.c:                                                 //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#include "CWACPSemaphore.h"

/****************************************************************/
/*                              WIN32                           */
/****************************************************************/
void CWACPSemaphore_Init(CWACPSemaphore *pObject, const char *pName, uint16 InitCount, uint16 MaxCount)
{
    pObject->hHandle = CreateSemaphore(NULL,InitCount,MaxCount,pName);
}

void CWACPSemaphore_Destroy(CWACPSemaphore *pObject)
{
    CloseHandle(pObject->hHandle);
    pObject->hHandle = NULL;
}

void CWACPSemaphore_Raise(const CWACPSemaphore *pObject)
{
    int Result;
 
    /* Only increment the semaphore count by 1 */
    Result = ReleaseSemaphore(pObject->hHandle, 1, NULL);

#if defined(TRACE_SERVER_ON)
    if (Result == 0)
        SYS_PRINTF("ReleaseSemaphore ret. err %d\n", GetLastError());
#endif
}

uint32 CWACPSemaphore_Wait(const CWACPSemaphore *pObject, uint32 Timeout)
{
    uint32 Result;
    Result = WaitForSingleObject(pObject->hHandle, Timeout);

#if defined(TRACE_SERVER_ON)
    if (Result == WAIT_FAILED)
        SYS_PRINTF("WaitForSingleObject ret. err %d\n", GetLastError());
#endif

    return(Result);
}






