/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWACPThread.c  :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/
#include "CWACPThread.h"

typedef unsigned (WINAPI *WACP_THREAD_PROC)(
    LPVOID lpThreadParameter
    );

/****************************************************************/
/*                              WIN32                           */
/****************************************************************/
void CWACPThread_Init(CWACPThread* pObject, THREAD_ID ThreadID)
{
    TOUCH(ThreadID);
    pObject->hHandle = NULL;
}

void CWACPThread_Destroy(CWACPThread* pObject)
{
    pObject->hHandle = NULL;
}


/************************************************************************************
CWACPThread_StartThread - Starts a thread specified by StartAdress and passes in
    the ArgList as the parameters.
**************************************************************************************/
boolean CWACPThread_StartThread(CWACPThread* pObject, uint32 (WACPAPI* StartAddress )(void*), 
                                void* pArgList, int32 ThreadPriority)
{
    boolean Result = FALSE;
    
    pObject->hHandle = (HANDLE)_beginthreadex(NULL, 0, (WACP_THREAD_PROC)StartAddress, pArgList, 0, NULL);
    
    if (pObject->hHandle)
    {
        Result = (boolean)SetThreadPriority(pObject->hHandle, ThreadPriority);
        CloseHandle(pObject->hHandle);
    }

    return (Result);
}

/*********************************************************************************
CWACPThread EndThread - Terminates the current thread. This is not to be used.
*********************************************************************************/
void CWACPThread_EndThread(CWACPThread* pObject)
{
    TOUCH(pObject);
    //ExitThread(0);
}




