/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Interchange.h  :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CINTERCHANGE_H)
    #define  CINTERCHANGE_H

#include <stdio.h>
#include "Target.h"
#include "StdVartyp.h"
#include "CCommSvr.h"

#if defined(TRACE_SERVER_ON)
#include "CTraceSvr.h"
#endif

#if defined(WIN32)
#include <process.h>
#endif

#define CRCSIZE (sizeof(uint16))

#define PACKET_LITE_HEADER_SIZE (sizeof(uint8) * PREAMBLE_SIZE \
                    + sizeof(uint32) \
                    + sizeof(uint16)) 

typedef struct PACKET
{
    uint8       Preamble[PREAMBLE_SIZE];
    uint32      PacketLen;
    uint16      Port;
    uint8*      DataBuffer;
    uint16      CRC;
}PACKET;

boolean Interchange_SendPacket(const char* pSourceID, const uint8* pBuf, uint32 BufSize);
boolean Interchange_RegisterCallback(void (*DataReadyEvent)(char* pSourceID, uint8* pBuf, uint32 BufSize));
boolean Interchange_RecvMsg(char* pSourceID, uint8* pBuf, uint32 MsgSize);
void    Interchange_Terminate(char* pSourceID, uint16 Port);

boolean Interchange_UpdateStatus(const char* pSourceID);
void    Interchange_Init(int32 Priority);
void    Interchange_Destroy(void);
boolean Interchange_Connect(ConnArgs** pConfig, uint8 NumConnections);
boolean Interchange_Disconnect(const char* pSourceID);

uint32 WACPAPI Interchange_RecvThread(void* pData);

uint8*  GeneratePacket(uint32 *OutSize, int16 Port, uint8* pBuf, uint32 Size);

#if defined(TRACE_SERVER_ON)
void Interchange_DebugPacket(uint8* pBuf, uint32 PacketLength);
#endif

#endif /* #if !defined(CINTERCHANGE_H) */

/*---------------------------------------------------*/
/* End of File */
