/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDStd.h                                                     //
'**  '// Version        :   1.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.7.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_NORMANDY_DLL.xml version 5.8
'*-E************************************************************************/

#if !defined(CDEVICEDSTD_H)
    #define  CDEVICEDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif

/*The following definition is the version.*/
#define CDEVDSTD_OBJECT_VERSION 100

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVDSTDtypSPECIES {
        CDEVDSTD_SpSTANDARD = 0, 
        CDEVDSTD_SpMAX
    } CDEVDSTD_SPECIES;

#define CDEVDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CDEVDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CDeviceDStd Member's Version Enumerations*/
    typedef  enum CDEVDSTDtypVERSIONS {
        CDEVDSTD_DateTime,
        CDEVDSTD_RunTime,
        CDEVDSTD_ModelName,
        CDEVDSTD_SerialNumber,
        CDEVDSTD_DeviceGUID,
        CDEVDSTD_MEMBER_MAX
    } CDEVDSTD_VERSIONS;

#define CDEVDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CDEVDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CDEVICEDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CDEVICEDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CDEVICEDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CDEVICEDSTD_DLLAPI
    #endif
#endif

class CDEVICEDSTD_DLLAPI CDeviceDStd : public DtData
{
public:
    CDeviceDStd();
    ~CDeviceDStd();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    MOIB_TIME GetDateTime();
    void SetDateTime(MOIB_TIME new_DateTime);

    uint32 GetRunTime();
    void SetRunTime(uint32 new_RunTime);

    ansichar* GetModelName(uint16* pSize);
    void SetModelName(ansichar* pBuf, uint16 Length);

    ansichar* GetSerialNumber(uint16* pSize);
    void SetSerialNumber(ansichar* pBuf, uint16 Length);

    uint8* GetDeviceGUID(uint16* pSize);
    void SetDeviceGUID(uint8* pBuf, uint16 Length);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CDeviceDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            MOIB_TIME     m_DateTime;
            uint32        m_RunTime;
            ansichar      m_ModelName[32];
            ansichar      m_SerialNumber[16];
            uint8         m_DeviceGUID[16];
    }ClassStruct_t;

#define CDEVDSTD_STATIC_STRUCT_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 16 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 48 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CDEVICEDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
