/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// Target.h       :                                                  //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(TARGET_H)
#define TARGET_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Simple macro to make compiler happy when function arguments are not used.
 */
#define TOUCH(X)    (X=X)

#define SEND_MSGPROC_TRAP(s, c, e)		SendTrap(s, c, e)
/*
 * Target Processor Types
 */
#define CPU_UNKNOWN     0   /* Unknown or generic CPU */
#define CPU_X86         1   /* Intel CPU Family */
#define CPU_6833X       2   /* Motorola 6833X CPU Family */
#define CPU_Z180        3   /* Zilog CPU Family */
#define CPU_68K         4   /* 68000 CPU Family */
#define CPU_H8X         5   /* Hitachi H8/H8s Family */
#define CPU_MXL         6   /* Motorola MC9328MXL */
#define CPU_C5000       7   /* Texas Instrument C5000 DSP */

/* 
 * Stack Type
 */
//#define STACK_ETHERNET 1
//#define STACK_SERIAL 1

#define DEFAULT_BAUD_RATE 115200

/*
 * Processor endian Types
 */
#define BIG_ENDIAN      1

/*
 * Endianness of date stream on the media.
 */
#define MEDIA_ENDIANNES         BIG_ENDIAN

/*
 * XML support
 */
#define XML_NONE        0
#define XML_SERIALIZE   1
#define XML_DESERIALIZE 2
#define XML_ALL         3


/******************************************/
/* Target Processor Dependent Definitions */
/******************************************/


/* Calling convention */
#define WACPAPI

/* Target specific parameters */
#define MAX_PACKET_SIZE         256

#if defined( __cplusplus )
}
#endif

#endif  /* #if !defined (TARGET_H) */

/* End of File */


