/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CBMIDStd.cpp                                                      //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#include "CBMIDStd.h"

const MsgEntry CBMIDStd::TypStatusTbl[] = {
    CBMIDSTD_Status_DATA_NOT_AVAIL , "NO_DESCRIPTION",
    CBMIDSTD_Status_DATA_COMPLETE, "NO_DESCRIPTION",
    CBMIDSTD_Status_DATA_FAILURE, "NO_DESCRIPTION",
    CBMIDSTD_Status_DATA_EXCEPTION, "NO_DESCRIPTION",
    CBMIDSTD_Status_DATA_PROCESSING, "NO_DESCRIPTION",
};

#define CBMIDSTD_TYPSTATUSTBL_SIZE \
    (sizeof(TypStatusTbl)/sizeof(TypStatusTbl[0]))

const MsgEntry CBMIDStd::TypExtStatusTbl[] = {
    CBMIDSTD_ExtStatus_NONE , "NO_DESCRIPTION",
};

#define CBMIDSTD_TYPEXTSTATUSTBL_SIZE \
    (sizeof(TypExtStatusTbl)/sizeof(TypExtStatusTbl[0]))

const MsgEntry CBMIDStd::TypSourceTbl[] = {
    CBMIDSTD_Source_NONE , "NO_DESCRIPTION",
    CBMIDSTD_Source_UNKNOWN, "NO_DESCRIPTION",
    CBMIDSTD_Source_COMPUTED , "NO_DESCRIPTION",
};

#define CBMIDSTD_TYPSOURCETBL_SIZE \
    (sizeof(TypSourceTbl)/sizeof(TypSourceTbl[0]))

const MsgEntry CBMIDStd::TypModeTbl[] = {
    CBMIDSTD_Mode_NONE , "NO_DESCRIPTION",
    CBMIDSTD_Mode_UNKNOWN, "NO_DESCRIPTION",
};

#define CBMIDSTD_TYPMODETBL_SIZE \
    (sizeof(TypModeTbl)/sizeof(TypModeTbl[0]))

const MsgEntry CBMIDStd::TypMethodTbl[] = {
    CBMIDSTD_Method_NONE , "NO_DESCRIPTION",
    CBMIDSTD_Method_UNKNOWN, "NO_DESCRIPTION",
    CBMIDSTD_Method_MANUAL, "NO_DESCRIPTION",
    CBMIDSTD_Method_DEVICE, "NO_DESCRIPTION",
    CBMIDSTD_Method_REMOTE, "NO_DESCRIPTION",
};

#define CBMIDSTD_TYPMETHODTBL_SIZE \
    (sizeof(TypMethodTbl)/sizeof(TypMethodTbl[0]))

const MsgEntry CBMIDStd::TypSpeciesTbl[] = {
    CBMIDSTD_SpSTANDARD, "NO_DESCRIPTION",
};

#define CBMIDSTD_TYPSPECIESTBL_SIZE \
    (sizeof(TypSpeciesTbl)/sizeof(TypSpeciesTbl[0]))

const VersionEntry CBMIDStd::TypVersionsTbl[] = {
    100, 101, /*CBMIDSTD_STime*/
    100, 101, /*CBMIDSTD_Status*/
    100, 101, /*CBMIDSTD_Weight*/
    100, 101, /*CBMIDSTD_Height*/
    100, 101, /*CBMIDSTD_BodyMassIndex*/
    100, 101, /*CBMIDSTD_ExtStatus*/
    100, 101, /*CBMIDSTD_Source*/
    100, 101, /*CBMIDSTD_Mode*/
    100, 101, /*CBMIDSTD_Method*/
};

/*================================================================================
    CONSTRUCTORS / DESTRUCTORS
================================================================================*/
/*********************************************************************************
  Default constructor
*********************************************************************************/
CBMIDStd::CBMIDStd() : DtData(MakeClassID(FmBODYMASSINDEX, GnDATA, CBMIDSTD_SpSTANDARD))
{
    /*The object starts life clean*/
    SetDataBitField(0);

    /*Initialize SrcVersion*/
    SetSrcVersion(0);

    /*Intialize the structure*/
    memset(&m_structData, 0, sizeof(m_structData));
}
/*********************************************************************************
  Default destructor
*********************************************************************************/
CBMIDStd::~CBMIDStd()
{
    Reset(TRUE);
}
/*********************************************************************************
Resets all members
*********************************************************************************/
void CBMIDStd::Reset(boolean bResetAll)
{
    TOUCH(bResetAll);

    /*Reset dirty and valid flags*/
    SetDataBitField(0);

    /*Reset SrcVersion*/
    SetSrcVersion(0);

    /*Reset static members*/
    memset(&m_structData, 0, sizeof(m_structData));
}
/*---------------------------------
 Static Members
---------------------------------*/
/*********************************************************************************
 Set function for data member STime
*********************************************************************************/
void CBMIDStd::SetSTime(MOIB_TIME new_STime)
{
    m_structData.m_STime = new_STime;
}
/*********************************************************************************
 Get function for data member STime
*********************************************************************************/
MOIB_TIME CBMIDStd::GetSTime()
{
    return (MOIB_TIME)m_structData.m_STime;
}
/*********************************************************************************
 Set function for data member Status
*********************************************************************************/
void CBMIDStd::SetStatus(uint16 new_Status)
{
    m_structData.m_Status = new_Status;
}
/*********************************************************************************
 Get function for data member Status
*********************************************************************************/
uint16 CBMIDStd::GetStatus()
{
    return (uint16)m_structData.m_Status;
}
/*********************************************************************************
 Set function for data member Weight
*********************************************************************************/
void CBMIDStd::SetWeight(uint32 new_Weight)
{
    m_structData.m_Weight = new_Weight;
}
/*********************************************************************************
 Get function for data member Weight
*********************************************************************************/
uint32 CBMIDStd::GetWeight()
{
    return (uint32)m_structData.m_Weight;
}
/*********************************************************************************
 Set function for data member Height
*********************************************************************************/
void CBMIDStd::SetHeight(uint32 new_Height)
{
    m_structData.m_Height = new_Height;
}
/*********************************************************************************
 Get function for data member Height
*********************************************************************************/
uint32 CBMIDStd::GetHeight()
{
    return (uint32)m_structData.m_Height;
}
/*********************************************************************************
 Set function for data member BodyMassIndex
*********************************************************************************/
void CBMIDStd::SetBodyMassIndex(uint32 new_BodyMassIndex)
{
    m_structData.m_BodyMassIndex = new_BodyMassIndex;
}
/*********************************************************************************
 Get function for data member BodyMassIndex
*********************************************************************************/
uint32 CBMIDStd::GetBodyMassIndex()
{
    return (uint32)m_structData.m_BodyMassIndex;
}
/*********************************************************************************
 Set function for data member ExtStatus
*********************************************************************************/
void CBMIDStd::SetExtStatus(uint16 new_ExtStatus)
{
    m_structData.m_ExtStatus = new_ExtStatus;
}
/*********************************************************************************
 Get function for data member ExtStatus
*********************************************************************************/
uint16 CBMIDStd::GetExtStatus()
{
    return (uint16)m_structData.m_ExtStatus;
}
/*********************************************************************************
 Set function for data member Source
*********************************************************************************/
void CBMIDStd::SetSource(uint16 new_Source)
{
    m_structData.m_Source = new_Source;
}
/*********************************************************************************
 Get function for data member Source
*********************************************************************************/
uint16 CBMIDStd::GetSource()
{
    return (uint16)m_structData.m_Source;
}
/*********************************************************************************
 Set function for data member Mode
*********************************************************************************/
void CBMIDStd::SetMode(uint8 new_Mode)
{
    m_structData.m_Mode = new_Mode;
}
/*********************************************************************************
 Get function for data member Mode
*********************************************************************************/
uint8 CBMIDStd::GetMode()
{
    return (uint8)m_structData.m_Mode;
}
/*********************************************************************************
 Set function for data member Method
*********************************************************************************/
void CBMIDStd::SetMethod(uint8 new_Method)
{
    m_structData.m_Method = new_Method;
}
/*********************************************************************************
 Get function for data member Method
*********************************************************************************/
uint8 CBMIDStd::GetMethod()
{
    return (uint8)m_structData.m_Method;
}
/*---------------------------------
 Dynamic Members
---------------------------------*/
/*================================================================================
    INHERITED / OVERIDDEN
================================================================================*/
/*********************************************************************************
Returns the version of the object. 
*********************************************************************************/
uint16 CBMIDStd::getVersion (void)
{
    return (uint16)CBMIDSTD_OBJECT_VERSION;
}
/*********************************************************************************
Returns the number of Bytes that would be used by the serialize_payload and
deserialize_payload methods.
*********************************************************************************/
uint32 CBMIDStd::get_payload_size (void)
{
    uint32 Size = 0;
    Size = sizeof(uint16)                /*Object Version*/
            + sizeof(byte)                /*is dirty flag*/
            + sizeof(uint16)                /*Size of the struct*/
            + (uint16)CBMIDSTD_STATIC_STRUCT_SIZE;    /*struct data size*/

    Size += sizeof(uint16);            /* CRC bytes */

    return Size;
}
/*********************************************************************************
Serialize the static data defined by m_structData.
*********************************************************************************/
void CBMIDStd::serialize_static_data(uint8QManager * QMgr)
{
    /* Enqueue only the  members of the Struct.*/
    /* Enqueue the MOIB_TIME structure here */
    Put_MOIBTIME(QMgr, m_structData.m_STime);

    QMgr->put(m_structData.m_Status);
    QMgr->put(m_structData.m_Weight);
    QMgr->put(m_structData.m_Height);
    QMgr->put(m_structData.m_BodyMassIndex);
    QMgr->put(m_structData.m_ExtStatus);
    QMgr->put(m_structData.m_Source);
    QMgr->put(m_structData.m_Mode);
    QMgr->put(m_structData.m_Method);
}
/*********************************************************************************
Deserialize the static data defined by m_structData.
*********************************************************************************/
void CBMIDStd::deserialize_static_data(uint8QManager *QMgr, uint16 StructSize)
{
    /* Dequeue only the  members of the Struct.*/
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_STime)))
    {
        /* Dequeue the MOIB_TIME structure here */
        m_structData.m_STime = Get_MOIBTIME(QMgr);
        StructSize -= sizeof(MOIB_TIME);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_Status)))
    {
        QMgr->get(&m_structData.m_Status);
        StructSize -= sizeof(uint16);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_Weight)))
    {
        QMgr->get(&m_structData.m_Weight);
        StructSize -= sizeof(uint32);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_Height)))
    {
        QMgr->get(&m_structData.m_Height);
        StructSize -= sizeof(uint32);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_BodyMassIndex)))
    {
        QMgr->get(&m_structData.m_BodyMassIndex);
        StructSize -= sizeof(uint32);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_ExtStatus)))
    {
        QMgr->get(&m_structData.m_ExtStatus);
        StructSize -= sizeof(uint16);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_Source)))
    {
        QMgr->get(&m_structData.m_Source);
        StructSize -= sizeof(uint16);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_Mode)))
    {
        QMgr->get(&m_structData.m_Mode);
        StructSize -= sizeof(uint8);
    }
    if((StructSize) &&
       (CBMIDSTD_VERSION_STATUS(CBMIDSTD_Method)))
    {
        QMgr->get(&m_structData.m_Method);
        StructSize -= sizeof(uint8);
    }
}
/*********************************************************************************
Used to place the data elements of the object into a circular queue. This
excludes the class identifier.
*********************************************************************************/
boolean CBMIDStd::serialize_payload(uint8QManager * QMgr)
{
    uint16    Version = getVersion();
    byte      *TailPtr;
    uint32    CRCLen;

    /* Save the start of the byte stream for calculating the CRC */
    TailPtr = (byte*)(QMgr->GetTailPtr());

    /* Enqueue the version */
    QMgr->put(Version);

    /* Enqueue the dirty State*/
    QMgr->put(GetDataBitField());

    /* Enqueue the Static Structure Size */
    QMgr->put((uint16)CBMIDSTD_STATIC_STRUCT_SIZE);

    /* Enqueue only the static members of the Struct */
    serialize_static_data(QMgr);

    /* Enqueue variable sized members and their sizes */

    /* Enqueue the CRC */
    CRCLen = QMgr->get_num_elements() - sizeof(uint16);
    QMgr->put(CalculateCRC(TailPtr,CRCLen));

    return TRUE;
}

/*********************************************************************************
Used to deserialize the data elements of the object from a circular queue. This
excludes the class identifier.
*********************************************************************************/
boolean CBMIDStd::deserialize_payload (uint8QManager * QMgr, uint32 Sz)
{
    /*These data pieces will need to be dequeued*/
    byte      BitField; 
    uint16    Version; 
    uint16    Size = 0; 
    byte      *pHeadPtr;
    uint16    CalcCRC;
    uint16    StoredCRC;
    uint32    CRCSize;
    uint32    Result = 0;

    /* Save the start of the byte stream for calculating the CRC */
    pHeadPtr = (byte*)(QMgr->GetHeadPtr());

    /* Calculate the CRC using just the payload and not the CRC Bytes*/
    CRCSize = QMgr->get_num_elements() - sizeof(uint16);
    CalcCRC = CalculateCRC(pHeadPtr, CRCSize);

    /* Index into the byte array to retrieve the stored CRC */
    StoredCRC = ReadInt16(&pHeadPtr[CRCSize]);

    /* Compare the Calculated and Stored CRC */
    if(CalcCRC == StoredCRC)
    {
        /* Dequeue the version */
        QMgr->get(&Version);

        if(Version <= CBMIDSTD_OBJECT_VERSION)
        {
            Result = 1;

            /* Reset the object before proceeding */
            Reset(TRUE);

            /* Store the dequeued version */
            SetSrcVersion(Version);

            /* Dequeue the dirty State */
            QMgr->get(&BitField);

            SetDataBitField(BitField);

            /* Dequeue the static member struct size */
            QMgr->get(&Size);

            /* Dequeue only the static members of the Struct */
            if(Size <= (uint16)CBMIDSTD_STATIC_STRUCT_SIZE)
            {
                deserialize_static_data(QMgr, Size);
#if defined(DEBUG_PRINT)
                if(Size < (uint16)CBMIDSTD_STATIC_STRUCT_SIZE)
                {
                    SYS_PRINTF("\nThe source object is smaller than the destination. Some source data will be lost.\n\n");
                }
#endif
            }
            else
            {
                uint8   *NewBuffer;
                NewBuffer = (uint8*)SYS_MALLOC(Sz);

                if(NewBuffer != NULL)
                {
                    deserialize_static_data(QMgr, (uint16)Sz);
#if defined(DEBUG_PRINT)
                    SYS_PRINTF("\nThe Source object is larger than the destination. Some destination data will not be intialized.\n\n");
#endif
                    /* Dequeue the remaining extra bytes of the static struct */
                    QMgr->dequeue_array(NewBuffer, Size - CBMIDSTD_STATIC_STRUCT_SIZE);

                    SYS_FREE(NewBuffer);
                }
            }

        }
    }

    if(Result == 0)
    {
        Reset(TRUE);
    }

    return (Result ? TRUE : FALSE);
}
#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
Writes the object into an XML file pointed to by the fhnd. Returns the number of
Bytes written into the file.
*********************************************************************************/
uint32 CBMIDStd::serialize_to_XMLbuf(char *pBuf)
{
    char Buffer[XML_BUFSIZE];
    char *Output = Buffer;
    uint32 NewSize   = 0;
    uint32 FinalSize = 0;
    uint32 ZeroSize  = 0;
    uint32 *pSizeCount = &ZeroSize;
    char TimeBuffer[128];
    char *pEnumName = NULL;

    /* If pBuf is NULL, then we don't write anything to it, and just 
    return the potential size */
    if(pBuf != NULL)
    {
        Output = pBuf;
        pSizeCount = &NewSize;
    }

    NewSize = sprintf(Output,
            /*XML formatted Output to file*/
            "<DEFINITION class=\"CBMIDStd\" version=\"%d\" "
                        "family=\"%d\" genus=\"%d\" species=\"%d\">\n",
            /*---------------------------------------------------------------*/
            /*Data for the related types above.
            uint16 representation Version*/
            getVersion(),
            family(),
            genus(),
            species());

            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;
            /*---------------------------------------------------------------*/
            /* -- MOIB_TIME value YYYY/MM/DD HH:MM:SS --*/
            NewSize = sprintf(Output, "<MEMBER type=\"TIME\" name=\"STime\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%s]]></VALUE>\n", timetostr(m_structData.m_STime, TimeBuffer));
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint16\" name=\"Status\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", m_structData.m_Status);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"Weight\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", m_structData.m_Weight);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"Height\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", m_structData.m_Height);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint32\" name=\"BodyMassIndex\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%lu]]></VALUE>\n", m_structData.m_BodyMassIndex);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint16\" name=\"ExtStatus\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", m_structData.m_ExtStatus);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint16\" name=\"Source\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", m_structData.m_Source);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" name=\"Mode\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", m_structData.m_Mode);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /* -- Integer Value --*/
            NewSize = sprintf(Output, "<MEMBER type=\"uint8\" name=\"Method\" minversion=\"100\" maxversion=\"CURRENT_VERSION\">\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "<VALUE><![CDATA[%u]]></VALUE>\n", m_structData.m_Method);
            FinalSize += NewSize;
            Output += *pSizeCount;

            NewSize = sprintf(Output, "</MEMBER>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            /*Write the closing members tag*/
            NewSize = sprintf(Output, "</MEMBERS>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

            if(IsValidEnum((MsgEntry*)TypStatusTbl,
                        CBMIDSTD_TYPSTATUSTBL_SIZE,
                        m_structData.m_Status))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"Status\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_Status)
                {
                    case 0:
                        pEnumName = "STATUS_DATA_NOT_AVAIL";
                        break;
                    case 1:
                        pEnumName = "STATUS_DATA_COMPLETE";
                        break;
                    case 2:
                        pEnumName = "STATUS_DATA_FAILURE";
                        break;
                    case 3:
                        pEnumName = "STATUS_DATA_EXCEPTION";
                        break;
                    case 4:
                        pEnumName = "STATUS_DATA_PROCESSING";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_Status);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CBMIDSTD_STATUS_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            if(IsValidEnum((MsgEntry*)TypExtStatusTbl,
                        CBMIDSTD_TYPEXTSTATUSTBL_SIZE,
                        m_structData.m_ExtStatus))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"ExtStatus\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_ExtStatus)
                {
                    case 0:
                        pEnumName = "EXTSTATUS_NONE";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_ExtStatus);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CBMIDSTD_EXTSTATUS_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            if(IsValidEnum((MsgEntry*)TypSourceTbl,
                        CBMIDSTD_TYPSOURCETBL_SIZE,
                        m_structData.m_Source))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"Source\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_Source)
                {
                    case 0:
                        pEnumName = "SOURCE_NONE";
                        break;
                    case 1:
                        pEnumName = "SOURCE_UNKNOWN";
                        break;
                    case 10:
                        pEnumName = "SOURCE_COMPUTED";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_Source);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CBMIDSTD_SOURCE_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            if(IsValidEnum((MsgEntry*)TypModeTbl,
                        CBMIDSTD_TYPMODETBL_SIZE,
                        m_structData.m_Mode))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"Mode\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_Mode)
                {
                    case 0:
                        pEnumName = "MODE_NONE";
                        break;
                    case 1:
                        pEnumName = "MODE_UNKNOWN";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_Mode);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CBMIDSTD_MODE_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            if(IsValidEnum((MsgEntry*)TypMethodTbl,
                        CBMIDSTD_TYPMETHODTBL_SIZE,
                        m_structData.m_Method))
            {
                NewSize = sprintf(Output, "<ENUMERATION name=\"Method\">\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                switch (m_structData.m_Method)
                {
                    case 0:
                        pEnumName = "METHOD_NONE";
                        break;
                    case 1:
                        pEnumName = "METHOD_UNKNOWN";
                        break;
                    case 2:
                        pEnumName = "METHOD_MANUAL";
                        break;
                    case 3:
                        pEnumName = "METHOD_DEVICE";
                        break;
                    case 4:
                        pEnumName = "METHOD_REMOTE";
                        break;
                }

                NewSize = sprintf(Output, "<ENUM name=\"%s\" defaultvalue=\"%d\" selected=\"yes\">\n", pEnumName, m_structData.m_Method);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "<DESCRIPTION language=\"English\"><![CDATA[%s]]></DESCRIPTION>\n", CBMIDSTD_METHOD_STRING);
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUM>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

                NewSize = sprintf(Output, "</ENUMERATION>\n");
                FinalSize += NewSize;
                Output += *pSizeCount;

            }

            /*---------------------------------------------------------------*/

            /*Write the closing definition tag*/
            NewSize = sprintf(Output, "</DEFINITION>\n");
            FinalSize += NewSize;
            Output += *pSizeCount;

    return FinalSize+1;
}
#endif  /* #if(TARGET_XML_SUPPORT==XML_ALL || TARGET_XML_SUPPORT==XML_SERIALIZE) */
#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
  The XML Parser makes a callback to this function whenever it encounters a start
  tag for an element. This function checks the string value of that element tag to
  decide what data it holds. It then sets the variable CurrentParsePos to point 
  at the data member corresponding with the tag string value. This CurrentParsePos 
  is used later by the parse_CharacterData() function to determine where the data 
  retrieved by parse_CharacterData() should be placed. 

  It also increments the DepthPtr for the current XML file. This value describes 
  the depth of the currently processed node.

 Ex: DepthPtr = 3:
 1 |-> <TAG1>
 2 |----> <TAG2>
 3 |-------> <TAG3>This element is 3 deep</TAG3>
          </TAG2>
      </TAG1>
*********************************************************************************/
void CBMIDStd::parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts)
{
    TOUCH(Atts);
    XMLParserData *ParserData = (XMLParserData*)UserData;

    /*Increment DepthPtr to track node depth*/
    uint32 *DepthPtr = &ParserData->Depth;
    *DepthPtr += 1;

    if(!validXMLParseFlag)
        return;

#if(DEBUG_PRINT)
    /*Debug information that will print to terminal screen
     *Prints tabspaces matching the DepthPtr, the name of 
     *element tag, and then...(onto parse_CharacterData)*/
    uint32 i;
    fputc('\n', stderr);
    for(i = 0; i < *DepthPtr; i++) fputc('\t', stderr);
    fprintf(stderr, "%-16s", Name);
#endif

    /* This area checks the current encountered tag. if it matches one that was
     * written in the serialize_to_XMLfile() function, then check its attributes
     * and attribute values */
    if((!strcmp("DEFINITION", Name)) && (GetClassAttr() == NULL))
    {
        while (*Atts)
        {
            /*As we parse the XML data, we check to see if the Family, 
             *Genus and Species match the current object. If they do not, 
             *we set validXMLParseFlag to FALSE. This will stop the parser 
             *from handling the additional data, and clear any data 
             *already in our structure.*/
            if(!strcmp(*Atts, "family"))
            {
                if(family() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "genus"))
            {
                if(genus() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "species"))
            {                                     
                if(species() != (uint8)atol(*++Atts))
                {
                    validXMLParseFlag = FALSE;
                    Reset(TRUE);
                }

                Atts++;
            }
            else if(!strcmp(*Atts, "version"))
            {
                SrcVersion = (uint16)atol(*++Atts);
                Atts++;
            }
            else Atts += 2;
        }
    }
    /*---------------------------------------------------------------*/
    else if (!strcmp("MEMBER", Name) && (GetClassAttr() == NULL))
    {
        /*Loop through the MEMBER attributes and
         *extract the attribute values*/
        while (*Atts)
        {
            if(!strcmp(*Atts, "name"))
            {
                Atts++;
                if(!strcmp(*Atts, "STime"))
                {
                    CurrentParsePos = (void*)&m_structData.m_STime;
                }
                else if(!strcmp(*Atts, "Status"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Status;
                }
                else if(!strcmp(*Atts, "Weight"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Weight;
                }
                else if(!strcmp(*Atts, "Height"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Height;
                }
                else if(!strcmp(*Atts, "BodyMassIndex"))
                {
                    CurrentParsePos = (void*)&m_structData.m_BodyMassIndex;
                }
                else if(!strcmp(*Atts, "ExtStatus"))
                {
                    CurrentParsePos = (void*)&m_structData.m_ExtStatus;
                }
                else if(!strcmp(*Atts, "Source"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Source;
                }
                else if(!strcmp(*Atts, "Mode"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Mode;
                }
                else if(!strcmp(*Atts, "Method"))
                {
                    CurrentParsePos = (void*)&m_structData.m_Method;
                }
                Atts++;
            }
            else Atts += 2;
        }
    }
    /*---------------------------------------------------------------*/
}
#endif/*TARGET_XML_SUPPORT*/

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
/*********************************************************************************
XML HELPER FUNCTION
  The XML Parser makes a callback to this function whenever it encounters
  character data after a start tag. This function also uses CurrentParsePos. This
  CurrentParsePos value has been set previously by the parse_StartElement
  function
*********************************************************************************/
void CBMIDStd::parse_CharacterData(void *UserData, const XML_Char *sTag, int Len)
{
    TOUCH(UserData);
    TOUCH(sTag);
    TOUCH(Len);
    /*Check to see if CurrentParsePos is NULL or points to something,
     *and if validXMLParseFlag is still true. If CurrentParsePos is
     *NULL, then this means we have encountered an element tag with 
     *no internal character data, and we pass it.*/
    if((CurrentParsePos && validXMLParseFlag) && (*sTag != '\n'))
    {
        if(CurrentParsePos == (void*)(&m_structData.m_STime))
        {
            /* -- MOIB_TIME value YYYY/MM/DD HH:MM:SS --*/
            xmltotime(sTag, m_structData.m_STime);
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Status))
        {
            SetStatus((uint16)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Weight))
        {
            SetWeight((uint32)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Height))
        {
            SetHeight((uint32)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_BodyMassIndex))
        {
            SetBodyMassIndex((uint32)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_ExtStatus))
        {
            SetExtStatus((uint16)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Source))
        {
            SetSource((uint16)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Mode))
        {
            SetMode((uint8)atol(sTag));
        }
        else if(CurrentParsePos == (void*)(&m_structData.m_Method))
        {
            SetMethod((uint8)atol(sTag));
        }
        /*---------------------------------------------------------------*/
#if(DEBUG_PRINT)
        /*(from parse_StartElement)...picks up from the start
         *element and prints the value following it*/
        fprintf(stderr, " = %s", sTag);
        if(!validXMLParseFlag)
            fprintf(stderr, " - Invalid Data: Stopping parse");
#endif
    }
}
#endif /*TARGET_XML_SUPPORT*/

/*================================================================================
Helper function for setting default values for the test functions
================================================================================*/
void CBMIDStd::SetObjectProperties(CBMIDStd *MyObjectSrc)
{/*Start SetObjectProperties()*/

    TOUCH(MyObjectSrc);
    /*
        MyObjectSrc->SetSTime();
        MyObjectSrc->SetStatus();
        MyObjectSrc->SetWeight();
        MyObjectSrc->SetHeight();
        MyObjectSrc->SetBodyMassIndex();
        MyObjectSrc->SetExtStatus();
        MyObjectSrc->SetSource();
        MyObjectSrc->SetMode();
        MyObjectSrc->SetMethod();
    */

}/*End SetObjectProperties()*/

/*================================================================================
CBMIDSTD_TEST_MAIN
================================================================================*/
#if defined(CBMIDSTD_TEST_MAIN)

FILE   *Stream;
uint8  *Buffer;
uint32 Size;
uint32 i;
int    Result, TestID;

CBMIDStd *MyObjectSrc = new CBMIDStd();
CBMIDStd *MyObjectDest = new CBMIDStd();

void XML_test();
void Serialize_All_test();

#if defined(_WIN32_WCE)
#if defined(_WCE_CONSOLE)
int WinEntry (void *Args)
{
    _newprintf = ((formatter*)Args)[0];
    _newscanf = ((formatter*)Args)[1];

#else
int WINAPI WinMain(HINSTANCE  hInstance,
                    HINSTANCE  hPrevInstance,
                    LPTSTR     lpCmdLine,
                    int  nCmdShow)
{
#endif
#else
int main(void)
{
#endif /*_WIN32_WCE*/

    SYS_PRINTF("1. Transfer XML from source object-->destination object.\n");
    SYS_PRINTF("2. Transfer complete byte stream: source object-->destination object.\n");
    SYS_PRINTF("Selection:");

    Result = scanf("%d", &TestID);

    MyObjectSrc->SetObjectProperties(MyObjectSrc);

    if(TestID == 1) XML_test();
    else if(TestID == 2)  Serialize_All_test();
    else{
        SYS_PRINTF("\n\nInvalid Selection.\n\n");
    }

    SYS_PRINTF("\n\nPress any character key and hit enter to continue.\n");
    Result = scanf("%d", &TestID);

    return 0;
}
/*================================================================================
Helper function for writing a byte Stream to a file
================================================================================*/
void WriteToFile(char *Buf, uint32 Size, char *Filename)
{
    FILE    *Fp;
    size_t  Bytes;

    if((Fp  = fopen(Filename, "w+b")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", Filename);
    }

    Bytes = fwrite(Buf, 1, Size, Fp);

    if(Bytes != Size)
    {
        SYS_PRINTF("Error: %d out of %d written to file %s\n", Bytes, strlen(Buf), Filename);
    }
    else
    {
        SYS_PRINTF("%s created\n", Filename);
    }

    if(fclose(Fp))
    {
        SYS_PRINTF("The file %s was not closed\n", Filename);
    }
}
/*================================================================================
Helper function for comparing the two generated xml files.
================================================================================*/
void CompareFiles(char *File1, char *File2)
{
    fpos_t    Pos;
    size_t    SrcLen;
    size_t    DestLen;
    FILE      *Fp1, *Fp2;
    char      *SrcBuf = NULL;
    char      *DestBuf = NULL;

    if((Fp1  = fopen(File1, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File1);
    }

    if((Fp2  = fopen(File2, "rb")) == NULL) 
    {
        SYS_PRINTF("The file %s was not opened\n", File2);
    }

    /*Get the current position of the file Stream*/
    fgetpos(Fp1, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp1, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    SrcLen = size_t(ftell(Fp1) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp1, &Pos);

    SrcBuf = (char*)SYS_REALLOC(SrcBuf, SrcLen);

    SrcLen = fread(SrcBuf, 1, SrcLen, Fp1);

    /*Get the current position of the file Stream*/
    fgetpos(Fp2, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Fp2, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    DestLen = size_t(ftell(Fp2) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Fp2, &Pos);

    DestBuf = (char*)SYS_REALLOC(DestBuf, DestLen);
    DestLen = fread(DestBuf, 1, DestLen, Fp2);

    if(DestLen == SrcLen)
    {
        for(i = 0; i < DestLen; i++)
        {
            if(DestBuf[i] != SrcBuf[i])
            {
                SYS_PRINTF("File mismatch at i=%d\n", i);
                break;
            }
        }
        if(i == DestLen)
            SYS_PRINTF("%s and %s comparison - PASSED!!!\n", File1, File2);
    }
    else
    {
        SYS_PRINTF("Error - File size mismatch\n");
    }

    if(fclose(Fp1))
    {
        SYS_PRINTF("The file %s was not closed\n",File2);
    }
    if(fclose(Fp2))
    {
        SYS_PRINTF("The file %s was not closed\n", File2);
    }

    SYS_FREE(SrcBuf);
    SYS_FREE(DestBuf);
}
/*================================================================================
XML_test
================================================================================*/
void XML_test()
{
    char   *XMLBuffer = NULL;
    uint32 BufferSize;

    if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = MyObjectSrc->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectSrc->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    /*Delete MyObjectSrc*/
    delete MyObjectSrc;

    /*Close the file*/
    if(fclose(Stream)) 
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    if((Stream  = fopen("XML_SerializeSrc.xml", "rb")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    fpos_t     Pos;

    /*Get the current position of the file Stream*/
    fgetpos(Stream, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Stream, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    BufferSize = (uint32)size_t(ftell(Stream) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Stream, &Pos);

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Return the bytes read in the file Stream to XMLBuffer*/
            fread(XMLBuffer, 1, BufferSize, Stream);

            /*Deserialize the XMLBuffer into MyObjectDest*/
            BufferSize = MyObjectDest->deserialize_from_XMLbuf(XMLBuffer, BufferSize);
        }
    }

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }
    if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
    }

    /*Get the size of MyObjectDest in an XML stream*/
    BufferSize = MyObjectDest->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectDest->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream,"</CMOIBObj>");

    /*Delete MyObjectDest*/
    delete MyObjectDest;

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
    }

    /*Compare the created XML files*/
    CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");

#endif
    /*Free Buffers*/
    SYS_FREE(XMLBuffer);
}
/*================================================================================
Serialize All
================================================================================*/
void Serialize_All_test()
{
    char    *XMLBuffer   = NULL;
    uint8   *ByteBuffer  = NULL;
    uint32  BufferSize;
    fpos_t  Pos;

    if((Stream  = fopen("XML_SerializeSrc.xml", "w+")) == NULL)
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not opened\n");
    }

    /*Get the size of MyObjectSrc in an XML stream*/
    BufferSize = MyObjectSrc->size_XML();

    /*Print the start tag of the XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_MALLOC(BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectSrc in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectSrc->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    /*Get the size of MyObjectSrc*/
    Size = MyObjectSrc->size_all();

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_MALLOC(Size);

    /*Serialize MyObjectSrc*/
    MyObjectSrc->serialize_all(ByteBuffer);

    /*Write the serialized ByteBuffer into the Serialize_AllSrc.bytestream file*/
    WriteToFile((char*)ByteBuffer, Size, "Serialize_AllSrc.bytestream");

    /*Delete MyObjectSrc*/ 
    delete MyObjectSrc;

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeSrc.xml was not closed\n");
    }

    if((Stream  = fopen("Serialize_AllSrc.bytestream", "rb+")) == NULL) 
    {
        SYS_PRINTF("The file Serialize_AllSrc.bytestream was not opened\n");
    }

    /*Get the current position of the file Stream*/
    fgetpos(Stream, &Pos);

    /*Set the file position to the end of the file*/
    fseek(Stream, 0l, SEEK_END);

    /*Get the size by subtracting the end of file - initial position.*/
    BufferSize = (uint32)size_t(ftell(Stream) - Pos);

    /*Set the current position back to the original*/
    fsetpos(Stream, &Pos);

    if(BufferSize)
    {
        ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, BufferSize);
        if(ByteBuffer != NULL)
        {
            /*Return the bytes read in the file Stream to ByteBuffer*/
            fread(ByteBuffer, 1, BufferSize, Stream);

            /*Deserialize the ByteBuffer into MyObjectDest*/
            BufferSize = MyObjectDest->deserialize_all((uint8*)ByteBuffer);
        }
    }

    if(fclose(Stream))
    {
        SYS_PRINTF("The file Serialize_AllSrc.bytestream was not closed\n");
    }

    if((Stream  = fopen("XML_SerializeDest.xml", "w+")) == NULL) 
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not opened\n");
    }

    /*Get the size of MyObjectDest in an XML stream*/
    BufferSize = MyObjectDest->size_XML();

    /*Print start tag of XML stream*/
    fprintf(Stream, "<CMOIBObj>\n");

    if(BufferSize)
    {
        XMLBuffer = (char*)SYS_REALLOC(XMLBuffer, BufferSize);
        if(XMLBuffer != NULL)
        {
            /*Serialize MyObjectDest in an XML stream to the XMLBuffer*/
            BufferSize = MyObjectDest->serialize_to_XMLbuf(XMLBuffer);

            /*Print the XML Stream to file*/
            fprintf(Stream, XMLBuffer);
        }
    }

    /*Print the end tag of the XML stream*/
    fprintf(Stream, "</CMOIBObj>");

    if(fclose(Stream))
    {
        SYS_PRINTF("The file XML_SerializeDest.xml was not closed\n");
    }

    /*Get the size of MyObjectDest*/
    Size = MyObjectDest->size_all();

    /*Allocate space for the serialized MyObjectSrc*/
    ByteBuffer = (uint8*)SYS_REALLOC(ByteBuffer, Size);

    /*Serialize MyObjectDest*/
    MyObjectDest->serialize_all(ByteBuffer);

    /*Write the serialized ByteBuffer into the Serialize_AllDest.bytestream file*/
    WriteToFile((char*)ByteBuffer, Size, "Serialize_AllDest.bytestream");

    /*Delete MyObjectDest*/ 
    delete MyObjectDest;

    /*Free buffers*/
    SYS_FREE(XMLBuffer);
    SYS_FREE(ByteBuffer);

    /*Compare created XML files and bytestream files*/
    CompareFiles("XML_SerializeSrc.xml", "XML_SerializeDest.xml");
    CompareFiles("Serialize_AllSrc.bytestream", "Serialize_AllDest.bytestream");
}
#endif /*#if defined(CBMIDSTD_TEST_MAIN)*/
/* ---------------------------End of DataClass CBMIDStd -------------------------------- */
