/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CBMIDStd.h                                                        //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CBMIDSTD_H)
    #define  CBMIDSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CBMIDSTD_OBJECT_VERSION 101

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CBMIDSTDtypSTATUS {
        CBMIDSTD_Status_DATA_NOT_AVAIL = 0, 
        CBMIDSTD_Status_DATA_COMPLETE, 
        CBMIDSTD_Status_DATA_FAILURE, 
        CBMIDSTD_Status_DATA_EXCEPTION, 
        CBMIDSTD_Status_DATA_PROCESSING, 
        CBMIDSTD_Status_MAX
    } CBMIDSTD_STATUS;

    typedef  enum CBMIDSTDtypEXTSTATUS {
        CBMIDSTD_ExtStatus_NONE = 0, 
        CBMIDSTD_ExtStatus_MAX
    } CBMIDSTD_EXTSTATUS;

    typedef  enum CBMIDSTDtypSOURCE {
        CBMIDSTD_Source_NONE = 0, 
        CBMIDSTD_Source_UNKNOWN, 
        CBMIDSTD_Source_COMPUTED = 10, 
        CBMIDSTD_Source_MAX
    } CBMIDSTD_SOURCE;

    typedef  enum CBMIDSTDtypMODE {
        CBMIDSTD_Mode_NONE = 0, 
        CBMIDSTD_Mode_UNKNOWN, 
        CBMIDSTD_Mode_MAX
    } CBMIDSTD_MODE;

    typedef  enum CBMIDSTDtypMETHOD {
        CBMIDSTD_Method_NONE = 0, 
        CBMIDSTD_Method_UNKNOWN, 
        CBMIDSTD_Method_MANUAL, 
        CBMIDSTD_Method_DEVICE, 
        CBMIDSTD_Method_REMOTE, 
        CBMIDSTD_Method_MAX
    } CBMIDSTD_METHOD;

    typedef  enum CBMIDSTDtypSPECIES {
        CBMIDSTD_SpSTANDARD, 
        CBMIDSTD_SpMAX
    } CBMIDSTD_SPECIES;

#define CBMIDSTD_STATUS_STRING \
    (GetMsgString((MsgEntry*)TypStatusTbl, \
                 CBMIDSTD_TYPSTATUSTBL_SIZE, \
                 m_structData.m_Status))

#define CBMIDSTD_EXTSTATUS_STRING \
    (GetMsgString((MsgEntry*)TypExtStatusTbl, \
                 CBMIDSTD_TYPEXTSTATUSTBL_SIZE, \
                 m_structData.m_ExtStatus))

#define CBMIDSTD_SOURCE_STRING \
    (GetMsgString((MsgEntry*)TypSourceTbl, \
                 CBMIDSTD_TYPSOURCETBL_SIZE, \
                 m_structData.m_Source))

#define CBMIDSTD_MODE_STRING \
    (GetMsgString((MsgEntry*)TypModeTbl, \
                 CBMIDSTD_TYPMODETBL_SIZE, \
                 m_structData.m_Mode))

#define CBMIDSTD_METHOD_STRING \
    (GetMsgString((MsgEntry*)TypMethodTbl, \
                 CBMIDSTD_TYPMETHODTBL_SIZE, \
                 m_structData.m_Method))

#define CBMIDSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CBMIDSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CBMIDStd Member's Version Enumerations*/
    typedef  enum CBMIDSTDtypVERSIONS {
        CBMIDSTD_STime,
        CBMIDSTD_Status,
        CBMIDSTD_Weight,
        CBMIDSTD_Height,
        CBMIDSTD_BodyMassIndex,
        CBMIDSTD_ExtStatus,
        CBMIDSTD_Source,
        CBMIDSTD_Mode,
        CBMIDSTD_Method,
        CBMIDSTD_MEMBER_MAX
    } CBMIDSTD_VERSIONS;

#define CBMIDSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CBMIDSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CBMIDSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CBMIDSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CBMIDSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CBMIDSTD_DLLAPI
    #endif
#endif

class CBMIDSTD_DLLAPI CBMIDStd : public DtData
{
public:
    CBMIDStd();
    ~CBMIDStd();

    /*---------------------------------
    CBMIDStd Functions:
    ---------------------------------*/
    MOIB_TIME GetSTime();
    void SetSTime(MOIB_TIME new_STime);

    uint16 GetStatus();
    void SetStatus(uint16 new_Status);

    uint32 GetWeight();
    void SetWeight(uint32 new_Weight);

    uint32 GetHeight();
    void SetHeight(uint32 new_Height);

    uint32 GetBodyMassIndex();
    void SetBodyMassIndex(uint32 new_BodyMassIndex);

    uint16 GetExtStatus();
    void SetExtStatus(uint16 new_ExtStatus);

    uint16 GetSource();
    void SetSource(uint16 new_Source);

    uint8 GetMode();
    void SetMode(uint8 new_Mode);

    uint8 GetMethod();
    void SetMethod(uint8 new_Method);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CBMIDStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            MOIB_TIME     m_STime; /* Time parameter was computed */
            uint16        m_Status; /* DATA_NOT_AVAIL, DATA_COMPLETE, etc */
            uint32        m_Weight; /* From the weight object 1 - 226kg in grams */
            uint32        m_Height; /* From the height object 1 - 254cm in millimeters */
            uint32        m_BodyMassIndex; /* BMI = weight/(height**2) in kg/m**2 */
            uint16        m_ExtStatus; /* Extended status/error code */
            uint16        m_Source; /* Source of data */
            uint8         m_Mode; /* Mode of operation */
            uint8         m_Method; /* Method used */
    }ClassStruct_t;

#define CBMIDSTD_STATIC_STRUCT_SIZE\
               (1 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 2 *(sizeof(uint8))   + 3 *(sizeof(uint16))\
                   + 3 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypStatusTbl[];
    static const MsgEntry    TypExtStatusTbl[];
    static const MsgEntry    TypSourceTbl[];
    static const MsgEntry    TypModeTbl[];
    static const MsgEntry    TypMethodTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CBMIDSTD_H) */

/*---------------------------------------------------*/
/* End of File */
