/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataTransferCDesc.h                                              //
'**  '// Version        :   2.01                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CDATATRANSFERCDESC_H)
    #define  CDATATRANSFERCDESC_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CDTACDSC_OBJECT_VERSION 201

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDTACDSCtypROLE {
        CDTACDSC_Role_NONE = 0, /*Indicates that a role is not specified*/
        CDTACDSC_Role_DATA_RECIPIENT, /*Indicates that the data source doesn't reside in the application and will be requested*/
        CDTACDSC_Role_DATA_SOURCE, /*Indicates that the data source resides on the application and will serve data.*/
        CDTACDSC_Role_MAX
    } CDTACDSC_ROLE;

    typedef  enum CDTACDSCtypSPECIES {
        CDTACDSC_SpDESCRIPTION = 1, /*Indicates it is a description of a proposed data transfer*/
        CDTACDSC_SpMAX
    } CDTACDSC_SPECIES;

#define CDTACDSC_ROLE_STRING \
    (GetMsgString((MsgEntry*)TypRoleTbl, \
                 CDTACDSC_TYPROLETBL_SIZE, \
                 m_structData.m_Role))

#define CDTACDSC_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CDTACDSC_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CDataTransferCDesc Member's Version Enumerations*/
    typedef  enum CDTACDSCtypVERSIONS {
        CDTACDSC_InitSeqNumber,
        CDTACDSC_TotalDataSize,
        CDTACDSC_DataPacketSize,
        CDTACDSC_Role,
        CDTACDSC_Identifier,
        CDTACDSC_Descriptor,
        CDTACDSC_WindowSize,
        CDTACDSC_MEMBER_MAX
    } CDTACDSC_VERSIONS;

#define CDTACDSC_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CDTACDSC_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CDATATRANSFERCDESC_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CDATATRANSFERCDESC_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CDATATRANSFERCDESC_DLLAPI  __declspec(dllimport)
    #else
        #define CDATATRANSFERCDESC_DLLAPI
    #endif
#endif

class CDATATRANSFERCDESC_DLLAPI CDataTransferCDesc : public DtData
{
public:
    CDataTransferCDesc();
    ~CDataTransferCDesc();

    /*---------------------------------
    CDataTransferCDesc Functions:
    ---------------------------------*/
    uint32 GetInitSeqNumber();
    void SetInitSeqNumber(uint32 new_InitSeqNumber);

    uint32 GetTotalDataSize();
    void SetTotalDataSize(uint32 new_TotalDataSize);

    uint16 GetDataPacketSize();
    void SetDataPacketSize(uint16 new_DataPacketSize);

    uint8 GetRole();
    void SetRole(uint8 new_Role);

    uint32 GetIdentifier();
    void SetIdentifier(uint32 new_Identifier);

    uint16 GetWindowSize();
    void SetWindowSize(uint16 new_WindowSize);

    boolean    InitDescriptor(uint32 Size);
    boolean    AppendDescriptor(uint8 *pBuffer, uint32 Size, uint16 NumberElements);
    void       DeleteDescriptor(void);
    uint8      *GetDescriptorAt(uint16 Index, uint32 *pSize);
    uint8      *GetDescriptor(uint32 *pSize);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CDataTransferCDesc *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_InitSeqNumber; /* Initial sequence number/byte offset of the data transfer. The sequence number is 1 based. A value of 0 indicates that it is not specified. */
            uint32        m_TotalDataSize; /* Total size of data being sent in bytes. */
            uint16        m_DataPacketSize; /* Maximum number of bytes in a 'packet' found in CDataTransferDExtStd::Data. The host/client will propose the max packet size in the intial configuration request and the client/host will respond with its agreed upon size (less than equal to initiator's max size) */
            uint8         m_Role; /* Describes where the Data is being transferred from. */
            uint32        m_Identifier; /* Used to uniquely identify the Data Transfer. */
            uint16        m_WindowSize; /* Identifies the number of outstanding request messages that can be received before the first response. A value of 0 indicates that it is not specified. Populated by the DATA_SOURCE */
    }ClassStruct_t;

#define CDTACDSC_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 1 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 3 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

    /*Record Data*/
    uint8    *m_Descriptor;
    uint32   m_DescriptorSize;
    uint32   m_DescriptorMaxSize;
    uint16   m_DescriptorElements;
    boolean  bDescriptorMaxSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypRoleTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CDATATRANSFERCDESC_H) */

/*---------------------------------------------------*/
/* End of File */
