/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CErrEStd.h                                                        //
'**  '// Version        :   1.05                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CERRESTD_H)
    #define  CERRESTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CERR_OBJECT_VERSION 105

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CERRtypERROR_COMMON {
        CERR_ERROR_COMMON_NONE = 0, 
        CERR_ERROR_COMMON_POST_FPROM, /*FPROM checksum error*/
        CERR_ERROR_COMMON_POST_SRAM, /*SRAM test failure*/
        CERR_ERROR_COMMON_POST_FACTORY, /*Factory settings checksum error*/
        CERR_ERROR_COMMON_POST_USER, /*User settings checksum error*/
        CERR_ERROR_COMMON_POST_ADC, /*A/D converter failure*/
        CERR_ERROR_COMMON_POST_SENSOR, /*SENSOR module failure*/
        CERR_ERROR_COMMON_POST_PRINTER, /*Printer problem*/
        CERR_ERROR_COMMON_POST_RTC, /*Real time clock failure*/
        CERR_ERROR_COMMON_POST_NO_CAL, /*No calibration signature*/
        CERR_ERROR_COMMON_POST_CAL_BAD, /*Bad calibration*/
        CERR_ERROR_COMMON_POST_VALVE, /*Stepper valve bad*/
        CERR_ERROR_COMMON_POST_LOG, /*Error log checksum error*/
        CERR_ERROR_COMMON_POST_EE_PATIENTDATA, /*Nonvolatile patient data lost*/
        CERR_ERROR_COMMON_POST_MAX, /*POST queue full*/
        CERR_ERROR_COMMON_POST_ERROR_CHECK, /*Validation check i.e. assert( code less than POST_ERROR_CHECK )*/
        CERR_ERROR_COMMON_POST_NOT_RDY, /*POST error code not yet ready*/
        CERR_ERROR_COMMON_POST_ATE_FAIL, /*The device has not gone through ATE successfully*/
        CERR_ERROR_COMMON_INVALID_ALGORITHM, /*Invalid Algorithm*/
        CERR_ERROR_COMMON_INVALID_INIT_CODE, /*Invalid Initiation Code*/
        CERR_ERROR_COMMON_INVALID_PMODE, /*Invalid Patient Mode*/
        CERR_ERROR_COMMON_INVALID_CONFIG, /*Invalid configuration for this action*/
        CERR_ERROR_COMMON_CYC_MALFUNC, /*Malfunction*/
        CERR_ERROR_COMMON_CYC_TEMPF, /*Ambient temp out of range*/
        CERR_ERROR_COMMON_VOLTAGE_BATTERY_LOW, /*Input voltage too low*/
        CERR_ERROR_COMMON_VOLTAGE_BATTERY_HIGH, /*Input voltage too high*/
        CERR_ERROR_COMMON_VOLTAGE_BAD_VIBES, /*Reference voltage unstable.*/
        CERR_ERROR_COMMON_PATH_NOT_FOUND, /*Path not found*/
        CERR_ERROR_COMMON_ACCESS_DENIED, /*Acess denied*/
        CERR_ERROR_COMMON_FILE_DELETED, /*File has been deleted*/
        CERR_ERROR_COMMON_FILE_EXPIRED, /*File has expired*/
        CERR_ERROR_COMMON_WRITE_FAILED, /*Write operation failed*/
        CERR_ERROR_COMMON_ERASE_FAILED, /*Erase operation failed*/
        CERR_ERROR_COMMON_MAX
    } CERR_ERROR_COMMON;

    typedef  enum CERRtypERROR_NIBP {
        CERR_ERROR_NIBP_NONE = 0, 
        CERR_ERROR_NIBP_POST_SAFETY_CAL_LOAD_FAIL, /*Failed to load the safety processors calibration record from its EEPROM.*/
        CERR_ERROR_NIBP_POST_SAFETY_ROM_CHECKSUM_FAIL, /*Safety processor has failed its ROM checksum*/
        CERR_ERROR_NIBP_POST_SAFETY_NOT_CALIBRATED, /*Safety processor not calibrated*/
        CERR_ERROR_NIBP_CYC_OVERP, /*Over pressure*/
        CERR_ERROR_NIBP_CYC_TOOSOON, /*Auto cycle skipped, too soon*/
        CERR_ERROR_NIBP_CYC_9MM, /*> 9 mm residual pressure > 3 mins*/
        CERR_ERROR_NIBP_CANT_CLEAR_FAILSAFE, /*Can't clear the failsafe alerts because one or more are still in violation.*/
        CERR_ERROR_NIBP_SAFETY_PROC_NO_RESPONSE, /*The safety processor has stopped responding.*/
        CERR_ERROR_NIBP_SAFETY_STAT_MODE_TOO_LONG, /*We have been in stat mode too long.*/
        CERR_ERROR_NIBP_SAFETY_XDCRFAIL, /*Both Transducers didn't agree*/
        CERR_ERROR_NIBP_COM_BADCHK, /*Bad checksum*/
        CERR_ERROR_NIBP_COM_BADCMD, /*Unimplemented command*/
        CERR_ERROR_NIBP_COM_BADDATA, /*Wrong data count*/
        CERR_ERROR_NIBP_COM_RANGE, /*Data range error*/
        CERR_ERROR_NIBP_COM_NOPOST, /*No POST error to clear*/
        CERR_ERROR_NIBP_COM_NOCLEAR, /*Can't clear this POST error*/
        CERR_ERROR_NIBP_COM_NOTCMD, /*Command not command type*/
        CERR_ERROR_NIBP_COM_TMOUT, /*Timeout*/
        CERR_ERROR_NIBP_COM_WRRESP, /*Response header wrong*/
        CERR_ERROR_NIBP_COM_RESP_BADCHK, /*Response checksum wrong*/
        CERR_ERROR_NIBP_COM_DATOVF, /*Too much received data*/
        CERR_ERROR_NIBP_COM_BADERASE, /*Nonvolatile memory block failed to be erased*/
        CERR_ERROR_NIBP_COM_BADPROG, /*Nonvolatile memory couldn't be programmed*/
        CERR_ERROR_NIBP_INVALID_TARGET_PRESS, /*Invalid inflation target pressure*/
        CERR_ERROR_NIBP_MAX
    } CERR_ERROR_NIBP;

    typedef  enum CERRtypERROR_SPO2 {
        CERR_ERROR_SPO2_NONE = 0, 
        CERR_ERROR_SPO2_BOARD_FAIL, /*Replace SpO2 Sensor Board*/
        CERR_ERROR_SPO2_BOARD_FAIL_STANDBY, /*Replace Spo2 Sensor Board if its not back in 15 sec*/
        CERR_ERROR_SPO2_BAD_PROBE, /*Bad probe was attached*/
        CERR_ERROR_SPO2_WRITE_CONFIG, /*Write config command did not take*/
        CERR_ERROR_SPO2_MAX
    } CERR_ERROR_SPO2;

    typedef  enum CERRtypERROR_TEMP {
        CERR_ERROR_TEMP_NONE = 0, 
        CERR_ERROR_TEMP_AD_PULSE_LONG, /*Thermistor A/D pulse too long*/
        CERR_ERROR_TEMP_AD_PULSE_SHORT, /*Thermistor A/D pulse too short*/
        CERR_ERROR_TEMP_AD_RCAL_LONG, /*Rcal resistor pulse too long*/
        CERR_ERROR_TEMP_AD_RCAL_SHORT, /*Rcal resistor pulse too short*/
        CERR_ERROR_TEMP_AD_PTB_OVER, /*PTB rsistor above 98.55F*/
        CERR_ERROR_TEMP_AD_PTB_UNDER, /*PTB resistor below 98.15F*/
        CERR_ERROR_TEMP_AD, /*A/D timeout error*/
        CERR_ERROR_TEMP_AD_PROBE_CALIBRATION, /*Probe calibration data is bad*/
        CERR_ERROR_TEMP_PROBE_WELL_REQUIRED, /*Device missing probe well.*/
        CERR_ERROR_TEMP_CONFIG_TRANSFER_FAILURE, /*Transfering the data has failed.*/
        CERR_ERROR_TEMP_CONFIG_CRC_FAILURE, /*Returned if the CRC check fails.*/
        CERR_ERROR_TEMP_CONFIG_CRC_FAILURE_PROBE, /*Returned if the probe CRC check fails.*/
        CERR_ERROR_TEMP_CONFIG_CRC_FAILURE_LOG, /*Returned if the Log CRC check fails.*/
        CERR_ERROR_TEMP_CONFIG_CAL_CRC_FAILURE, /*Returned if the calibration CRC check fails*/
        CERR_ERROR_TEMP_CONFIG_NO_PROBE, /*If there is no probe this error will be returned.*/
        CERR_ERROR_TEMP_CONFIG_UNINITIALIZED_PROBE, /*If the probe is missing the header then this probe is not initialized.*/
        CERR_ERROR_TEMP_EVENTS_INVALID_INDEX, /*If the index passed in is not valid this is returned*/
        CERR_ERROR_TEMP_CONFIG_SLAVE_ACK_FAILURE, /*Returned if the slave does not acknowledge us with an ack when apropriate.*/
        CERR_ERROR_TEMP_CONFIG_NULL_CHAR_FAILURE, /*Returned if when reading the data from the probe we fail to get a valid null character.*/
        CERR_ERROR_TEMP_CONFIG_ACQUIRE_FAILURE, /*If the timeout occurs when trying to do the aquire then there is a problem.  Either the resourse was never released properly, or the timeout is to quick.*/
        CERR_ERROR_TEMP_CONFIG_RELEASE_FAILURE, /*Will be returned if an invalid pointer is passed in or if the current task is not the owner of the lock.*/
        CERR_ERROR_TEMP_CONFIG_INVALID_PTR_FAILURE, /*Will be returned from the get, and set routines for the on board eeprom if the ptr passed in does not match the config object.  Suggests that acquire was not performed properly and we have either an invalid ptr or an extra copy of the device config object.*/
        CERR_ERROR_TEMP_CONFIG_INITIALIZE_FAILURE, /*If writing out the newly initialized data fails then return an initialization falure error*/
        CERR_ERROR_TEMP_HEATER_ON, /*Heater on when circuit is disabled and off.*/
        CERR_ERROR_TEMP_HEATER_OFF, /*Heater off when circuit is driving it.*/
        CERR_ERROR_TEMP_HEATER_VOLTAGE_HIGH_Q, /*HTR_Q on and HTRC is off but still have voltage.*/
        CERR_ERROR_TEMP_HEATER_VOLTAGE_Q_HIGH_IMPEDANCE, /*HTR_Q is tri-stated with HTRC enabled and have heater power.*/
        CERR_ERROR_TEMP_HEATER_VOLTAGE_LOW, /*Turned Q+C on and heater voltage no high enough.*/
        CERR_ERROR_TEMP_HEATER_FAILSAFE, /*Failsafe did not kick in.*/
        CERR_ERROR_TEMP_PROBE_OVER_TEMP, /*probe temperature exceeds 112 F*/
        CERR_ERROR_TEMP_EXCESSIVE_HEATER_ENERGY, /*total heater energy exceeded specified limit*/
        CERR_ERROR_TEMP_HOST_INTERFACE_ERROR, /*host system has violated the interface rules*/
        CERR_ERROR_TEMP_OVER_AMBIENT_TEMP, /*ambient temp too high*/
        CERR_ERROR_TEMP_UNDER_AMBIENT_TEMP, /*ambient temp too low*/
        CERR_ERROR_TEMP_INVALID_SURETEMP_ALGO, /*invalid suretemp prediction algorithm designation*/
        CERR_ERROR_TEMP_OVER_MAX_BATT_VOLTS, /*max heater current value too large*/
        CERR_ERROR_TEMP_UNDER_MIN_BATT_VOLTS, /*max heater current value too small*/
        CERR_ERROR_TEMP_BATT_VOLTS_NOT_SET, /*tried to init oral/axil probe w/o setting batt volts*/
        CERR_ERROR_TEMP_PRED_ALGO_NOT_SET, /*a prediction algo not specified*/
        CERR_ERROR_TEMP_AMBIENT_TEMP_NOT_SET, /*the ambient temp has not been set*/
        CERR_ERROR_TEMP_NO_PROBE_TEMP_RISE, /*non responsive probe*/
        CERR_ERROR_TEMP_BAD_PROBE_GAIN, /*probe gain outside limits*/
        CERR_ERROR_TEMP_BAD_PROBE_RESP_VAL, /*probe response info outside limits*/
        CERR_ERROR_TEMP_MAX
    } CERR_ERROR_TEMP;

    typedef  enum CERRtypERROR_DISPLAY {
        CERR_ERROR_DISPLAY_NONE = 0, 
        CERR_ERROR_DISPLAY_DISPLAY_BACKLIGHT_FAILURE, /*Display backlight error*/
        CERR_ERROR_DISPLAY_MAX
    } CERR_ERROR_DISPLAY;

    typedef  enum CERRtypERROR_BATTERY {
        CERR_ERROR_BATTERY_NONE = 0, 
        CERR_ERROR_BATTERY_BATTERY_MISSING, /*Device does not contain a battery*/
        CERR_ERROR_BATTERY_BATTERY_CHARGE_FAILURE, /*Device can not charge battery*/
        CERR_ERROR_BATTERY_MAX
    } CERR_ERROR_BATTERY;

    typedef  enum CERRtypERROR_PRINTER {
        CERR_ERROR_PRINTER_NONE = 0, 
        CERR_ERROR_PRINTER_VOLTAGE_ERROR, 
        CERR_ERROR_PRINTER_RECEIVE_DATA_ERROR, 
        CERR_ERROR_PRINTER_HEAD_UP, 
        CERR_ERROR_PRINTER_CUTTER_ERROR, 
        CERR_ERROR_PRINTER_HARDWARE_ERROR, 
        CERR_ERROR_PRINTER_THERMAL_ERROR, 
        CERR_ERROR_PRINTER_MOTOR_ERROR, 
        CERR_ERROR_PRINTER_PAPER_NEAR_END, 
        CERR_ERROR_PRINTER_MARK_DETECTION_ERROR, 
        CERR_ERROR_PRINTER_PAPER_OUT, 
        CERR_ERROR_PRINTER_JAM, 
        CERR_ERROR_PRINTER_OTHER_ERROR, 
        CERR_ERROR_PRINTER_MAX
    } CERR_ERROR_PRINTER;

    /* AppInternal Errors */
    typedef enum CERRtypAPPERROR {
        CERR_APP_MAX
    } CERR_APPLIST;

    /* WACP Stack Errors */
    typedef enum CERRtypSTACKERROR {
        CERR_NONE = 0,
        CERR_INVL_FAMILY,
        CERR_INVL_GENUS,
        CERR_INVL_SPECIES,
        CERR_OBJECT_ID,
        CERR_CRC_MISMATCH,  
        CERR_INVL_TBL_ENTRY,
        CERR_DUP_ENTRY,
        CERR_MAX
    } CERR_STACKLIST;

    /* WACP Message Processing Errors */
    typedef enum CERRtypPROCERROR {
        CERR_PROC_NONE = 0,
        CERR_PROC_UNIMPL,
        CERR_PROC_UNSUPPORTED,
        CERR_PROC_MEMORY,
        CERR_PROC_NO_PARAM,
        CERR_PROC_INVL_PARAM,
        CERR_PROC_INVL_PARAM_RANGE,
        CERR_PROC_NO_OBJECT,
        CERR_PROC_OBJECT_DESERIALIZE,
        CERR_PROC_OBJECT_SERIALIZE,
        CERR_PROC_CONTEXT,
        CERR_PROC_ITEM_NOT_AVAILABLE,
        CERR_PROC_MAX
    } CERR_PROCLIST;

    typedef  enum CERRtypSPECIES {
        CERR_SpERRNONE = 0, 
        CERR_SpERRWACPSTACK, /*Trap message for WACP Stack errors. Errors that could occur while processing a WACP message within the stack. The ErrorCode member contains enumerated values from the CERR_STACKLIST enumeration that is generated by AppGen(Refer to CErrEStd.h)*/
        CERR_SpERRMSGPROC, /*Trap message for Processing errors. Errors that can occur while processing messages in the application. The ErrorCode member contains enumerated values from the CERR_PROCLIST enumeration that is generated by AppGen(Refer to CErrEStd.h)*/
        CERR_SpERRAPPINTERNAL, /*Trap message for Application errors. The ErrorCode member contains enumerated values from application defined in the ErrorCode enumeration.*/
        CERR_SpERROR_RESERVED, /*Reserved for WACP Stack Usage.*/
        CERR_SpERROR_COMMON, /*Common Application errors. The ErrorCode member contains enumerated values from the ERROR_COMMON enumeration.*/
        CERR_SpERROR_NIBP, /*NIBP Application errors. The ErrorCode member contains enumerated values from the ERROR_NIBP enumeration.*/
        CERR_SpERROR_SPO2, /*SpO2 Application errors. The ErrorCode member contains enumerated values from the ERROR_SPO2 enumeration.*/
        CERR_SpERROR_TEMP, /*Temp Application errors. The ErrorCode member contains enumerated values from the ERROR_TEMP enumeration.*/
        CERR_SpERROR_ECG, /*ECG Application errors. The ErrorCode member contains enumerated values from the ERROR_ECG enumeration.*/
        CERR_SpERROR_CO2, /*CO2 Application errors. The ErrorCode member contains enumerated values from the ERROR_CO2 enumeration.*/
        CERR_SpERROR_TYMP, /*TYMP Application errors. The ErrorCode member contains enumerated values from the ERROR_TYMP enumeration.*/
        CERR_SpERROR_PRINTER, /*PRINTER Application errors. The ErrorCode member contains enumerated values from the ERROR_PRINTER enumeration.*/
        CERR_SpERROR_DISPLAY, /*DISPLAY Application errors. The ErrorCode member contains enumerated values from the ERROR_DISPLAY enumeration.*/
        CERR_SpERROR_BATTERY, /*Battery Application errors. The ErrorCode member contains enumerated values from the ERROR_BATTERY enumeration.*/
        CERR_SpMAX
    } CERR_SPECIES;

#define CERR_ERROR_COMMON_STRING \
    (GetMsgString((MsgEntry*)TypERROR_COMMONTbl, \
                 CERR_TYPERROR_COMMONTBL_SIZE, \
                 m_structData.m_ERROR_COMMON))

#define CERR_ERROR_NIBP_STRING \
    (GetMsgString((MsgEntry*)TypERROR_NIBPTbl, \
                 CERR_TYPERROR_NIBPTBL_SIZE, \
                 m_structData.m_ERROR_NIBP))

#define CERR_ERROR_SPO2_STRING \
    (GetMsgString((MsgEntry*)TypERROR_SPO2Tbl, \
                 CERR_TYPERROR_SPO2TBL_SIZE, \
                 m_structData.m_ERROR_SPO2))

#define CERR_ERROR_TEMP_STRING \
    (GetMsgString((MsgEntry*)TypERROR_TEMPTbl, \
                 CERR_TYPERROR_TEMPTBL_SIZE, \
                 m_structData.m_ERROR_TEMP))

#define CERR_ERROR_DISPLAY_STRING \
    (GetMsgString((MsgEntry*)TypERROR_DISPLAYTbl, \
                 CERR_TYPERROR_DISPLAYTBL_SIZE, \
                 m_structData.m_ERROR_DISPLAY))

#define CERR_ERROR_BATTERY_STRING \
    (GetMsgString((MsgEntry*)TypERROR_BATTERYTbl, \
                 CERR_TYPERROR_BATTERYTBL_SIZE, \
                 m_structData.m_ERROR_BATTERY))

#define CERR_ERROR_PRINTER_STRING \
    (GetMsgString((MsgEntry*)TypERROR_PRINTERTbl, \
                 CERR_TYPERROR_PRINTERTBL_SIZE, \
                 m_structData.m_ERROR_PRINTER))

#define CERR_STACK_STRING \
    (GetMsgString((MsgEntry*)TypStackErrorTbl, \
                 CERR_TYPSTACKERRORTBL_SIZE, \
                 m_structData.m_ErrorCode))

#define CERR_MSGPROC_STRING \
    (GetMsgString((MsgEntry*)TypMsgProcErrorTbl, \
                 CERR_TYPMSGPROCERRORTBL_SIZE, \
                 m_structData.m_ErrorCode))

#define CERR_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CERR_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CErrEStd Member's Version Enumerations*/
    typedef  enum CERRtypVERSIONS {
        CERR_ErrClassID,
        CERR_ErrorCode,
        CERR_Description,
        CERR_Data,
        CERR_MEMBER_MAX
    } CERR_VERSIONS;

#define CERR_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CERR_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CERRESTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CERRESTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CERRESTD_DLLAPI  __declspec(dllimport)
    #else
        #define CERRESTD_DLLAPI
    #endif
#endif

class CERRESTD_DLLAPI CErrEStd : public DtData
{
public:
    CErrEStd();
    ~CErrEStd();

    /*---------------------------------
    CErrEStd Functions:
    ---------------------------------*/
    uint32 GetErrClassID();
    void SetErrClassID(uint32 new_ErrClassID);

    uint16 GetErrorCode();
    void SetErrorCode(uint16 new_ErrorCode);

    ansichar* GetDescription(uint16* pSize);
    void SetDescription(ansichar* pBuf, uint16 Length);

    uint8* GetData(uint16* pSize);
    void SetData(uint8* pBuf, uint16 NumElements);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CErrEStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_ErrClassID; /* ClassID of message or object that generated the error */
            uint16        m_ErrorCode; /* Error code from message */
            ansichar      m_Description[20]; /* Error code description */
    }ClassStruct_t;

#define CERR_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 20 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


    /*Dynamic Data*/
    uint8             *m_Data; /* Can contain any data for a received process. */
    uint16            m_DataSize;
protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypERROR_COMMONTbl[];
    static const MsgEntry    TypERROR_NIBPTbl[];
    static const MsgEntry    TypERROR_SPO2Tbl[];
    static const MsgEntry    TypERROR_TEMPTbl[];
    static const MsgEntry    TypERROR_DISPLAYTbl[];
    static const MsgEntry    TypERROR_BATTERYTbl[];
    static const MsgEntry    TypERROR_PRINTERTbl[];
    static const MsgEntry    TypStackErrorTbl[];
    static const MsgEntry    TypMsgProcErrorTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CERRESTD_H) */

/*---------------------------------------------------*/
/* End of File */
