/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashPMsgArg.h                                                   //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CFLASHPMSGARG_H)
    #define  CFLASHPMSGARG_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CFLSPMSA_OBJECT_VERSION 200

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CFLSPMSAtypMODEID {
        CFLSPMSA_ModeID_NONE = 0, /*None*/
        CFLSPMSA_ModeID_BOOTLOADER = 1, /*Indicates that the upgrade will occur in the Bootloader mode*/
        CFLSPMSA_ModeID_APPLICATION = 2, /*Indicates that the upgrade will occur in the Application mode*/
        CFLSPMSA_ModeID_MAX
    } CFLSPMSA_MODEID;

    typedef  enum CFLSPMSAtypIMAGEID {
        CFLSPMSA_ImageID_NONE = 0, /*None*/
        CFLSPMSA_ImageID_BOOTLOADER = 1, /*Indicates that the bootloader is being upgraded*/
        CFLSPMSA_ImageID_APPLICATION = 2, /*Indicates that the application is being upgraded*/
        CFLSPMSA_ImageID_MAX
    } CFLSPMSA_IMAGEID;

    typedef  enum CFLSPMSAtypSPECIES {
        CFLSPMSA_SpMSG_ARGUMENTS = 1, /*Default species. Generic Message Argument.*/
        CFLSPMSA_SpMODE = 2, /*IOParameterA is used for the enumerated ModeID. IOParameterB is reserved.*/
        CFLSPMSA_SpDESCRIPTION = 3, /*IOParameterA is used for the ImageID. IOParameterB is used for the ImageSize(total byte size of the image).*/
        CFLSPMSA_SpPREP_CONFIGURATION = 4, /*IOParameterA is used for PreparationWaitTime (a value that indicates the expected wait time that it takes to prepare the memory). IOParameterB is reserved.*/
        CFLSPMSA_SpPROG_CONFIGURATION = 5, /*IOParameterA is used for ProgramWaitTime (a value that indicates the expected wait time that it takes to program the memory).  IOParameterB is used for ChunkSize (a value that indicates the maxmimum chunk size that the device can support).*/
        CFLSPMSA_SpMAX
    } CFLSPMSA_SPECIES;

#define CFLSPMSA_MODEID_STRING \
    (GetMsgString((MsgEntry*)TypModeIDTbl, \
                 CFLSPMSA_TYPMODEIDTBL_SIZE, \
                 m_structData.m_ModeID))

#define CFLSPMSA_IMAGEID_STRING \
    (GetMsgString((MsgEntry*)TypImageIDTbl, \
                 CFLSPMSA_TYPIMAGEIDTBL_SIZE, \
                 m_structData.m_ImageID))

#define CFLSPMSA_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CFLSPMSA_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CFlashPMsgArg Member's Version Enumerations*/
    typedef  enum CFLSPMSAtypVERSIONS {
        CFLSPMSA_IOParameterA,
        CFLSPMSA_IOParameterB,
        CFLSPMSA_MEMBER_MAX
    } CFLSPMSA_VERSIONS;

#define CFLSPMSA_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CFLSPMSA_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CFLASHPMSGARG_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CFLASHPMSGARG_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CFLASHPMSGARG_DLLAPI  __declspec(dllimport)
    #else
        #define CFLASHPMSGARG_DLLAPI
    #endif
#endif

class CFLASHPMSGARG_DLLAPI CFlashPMsgArg : public DtData
{
public:
    CFlashPMsgArg();
    ~CFlashPMsgArg();

    /*---------------------------------
    CFlashPMsgArg Functions:
    ---------------------------------*/
    uint32 GetIOParameterA();
    void SetIOParameterA(uint32 new_IOParameterA);

    uint32 GetIOParameterB();
    void SetIOParameterB(uint32 new_IOParameterB);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CFlashPMsgArg *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            uint32        m_IOParameterA; /* Generic parameter used for ImageID/ModeID/PreparationWaitTime(msec)/ProgramWaitTime(msec) */
            uint32        m_IOParameterB; /* Generic parameter used for ImageSize/ChunkSize */
    }ClassStruct_t;

#define CFLSPMSA_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 2 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypModeIDTbl[];
    static const MsgEntry    TypImageIDTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CFLASHPMSGARG_H) */

/*---------------------------------------------------*/
/* End of File */
