/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CHeightCStd.h                                                     //
'**  '// Version        :   1.04                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CHEIGHTCSTD_H)
    #define  CHEIGHTCSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CHGTCSTD_OBJECT_VERSION 104

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CHGTCSTDtypHEIGHTDISPLAYUNITS {
        CHGTCSTD_HeightDisplayUnits_UNITS_CENTIMETRES, 
        CHGTCSTD_HeightDisplayUnits_UNITS_INCHES, 
        CHGTCSTD_HeightDisplayUnits_UNITS_FEET_INCHES, 
        CHGTCSTD_HeightDisplayUnits_MAX
    } CHGTCSTD_HEIGHTDISPLAYUNITS;

    typedef  enum CHGTCSTDtypEXTERNALPORT {
        CHGTCSTD_ExternalPort_NONE = 0, 
        CHGTCSTD_ExternalPort_UNKNOWN, 
        CHGTCSTD_ExternalPort_PORT_1 = 10, 
        CHGTCSTD_ExternalPort_PORT_2, 
        CHGTCSTD_ExternalPort_PORT_3, 
        CHGTCSTD_ExternalPort_PORT_4, 
        CHGTCSTD_ExternalPort_MAX
    } CHGTCSTD_EXTERNALPORT;

    typedef  enum CHGTCSTDtypSPECIES {
        CHGTCSTD_SpSTANDARD = 0, 
        CHGTCSTD_SpMAX
    } CHGTCSTD_SPECIES;

#define CHGTCSTD_HEIGHTDISPLAYUNITS_STRING \
    (GetMsgString((MsgEntry*)TypHeightDisplayUnitsTbl, \
                 CHGTCSTD_TYPHEIGHTDISPLAYUNITSTBL_SIZE, \
                 m_structData.m_HeightDisplayUnits))

#define CHGTCSTD_EXTERNALPORT_STRING \
    (GetMsgString((MsgEntry*)TypExternalPortTbl, \
                 CHGTCSTD_TYPEXTERNALPORTTBL_SIZE, \
                 m_structData.m_ExternalPort))

#define CHGTCSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CHGTCSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CHeightCStd Member's Version Enumerations*/
    typedef  enum CHGTCSTDtypVERSIONS {
        CHGTCSTD_Enabled,
        CHGTCSTD_ManualHeight,
        CHGTCSTD_HeightDisplayUnits,
        CHGTCSTD_HeightDefault,
        CHGTCSTD_ExternalPort,
        CHGTCSTD_MEMBER_MAX
    } CHGTCSTD_VERSIONS;

#define CHGTCSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CHGTCSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CHEIGHTCSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CHEIGHTCSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CHEIGHTCSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CHEIGHTCSTD_DLLAPI
    #endif
#endif

class CHEIGHTCSTD_DLLAPI CHeightCStd : public DtData
{
public:
    CHeightCStd();
    ~CHeightCStd();

    /*---------------------------------
    CHeightCStd Functions:
    ---------------------------------*/
    boolean GetEnabled();
    void SetEnabled(boolean new_Enabled);

    boolean GetManualHeight();
    void SetManualHeight(boolean new_ManualHeight);

    uint16 GetHeightDisplayUnits();
    void SetHeightDisplayUnits(uint16 new_HeightDisplayUnits);

    uint32 GetHeightDefault();
    void SetHeightDefault(uint32 new_HeightDefault);

    uint16 GetExternalPort();
    void SetExternalPort(uint16 new_ExternalPort);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CHeightCStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            boolean       m_Enabled; /* True if enabled */
            boolean       m_ManualHeight; /* True if enabled */
            uint16        m_HeightDisplayUnits; /* Centimeters, inches, feet inches */
            uint32        m_HeightDefault; /* Value presented to user on a new record 1 - 254cm in millimeters */
            uint16        m_ExternalPort; /* Device port for external height device */
    }ClassStruct_t;

#define CHGTCSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 2 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypHeightDisplayUnitsTbl[];
    static const MsgEntry    TypExternalPortTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CHEIGHTCSTD_H) */

/*---------------------------------------------------*/
/* End of File */
