/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CWeightCStd.h                                                     //
'**  '// Version        :   1.03                                           //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Healthometer.xml version 1
'*-E************************************************************************/

#if !defined(CWEIGHTCSTD_H)
    #define  CWEIGHTCSTD_H

/*Windows CE doesn't support streams through standard libraries, so
  streams are no longer used.
  #include <stdiostr.h>*/

#include "DtData.h"

#if defined(_WIN32_WCE)
#include "windows.h"
#endif


/*The following definition is the version.*/
#define CWGHCSTD_OBJECT_VERSION 103

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CWGHCSTDtypWEIGHTDISPLAYUNITS {
        CWGHCSTD_WeightDisplayUnits_UNITS_LBS, 
        CWGHCSTD_WeightDisplayUnits_UNITS_KG, 
        CWGHCSTD_WeightDisplayUnits_MAX
    } CWGHCSTD_WEIGHTDISPLAYUNITS;

    typedef  enum CWGHCSTDtypEXTERNALPORT {
        CWGHCSTD_ExternalPort_NONE = 0, 
        CWGHCSTD_ExternalPort_UNKNOWN, 
        CWGHCSTD_ExternalPort_PORT_1 = 10, 
        CWGHCSTD_ExternalPort_PORT_2, 
        CWGHCSTD_ExternalPort_PORT_3, 
        CWGHCSTD_ExternalPort_PORT_4, 
        CWGHCSTD_ExternalPort_MAX
    } CWGHCSTD_EXTERNALPORT;

    typedef  enum CWGHCSTDtypSPECIES {
        CWGHCSTD_SpSTANDARD = 0, 
        CWGHCSTD_SpMAX
    } CWGHCSTD_SPECIES;

#define CWGHCSTD_WEIGHTDISPLAYUNITS_STRING \
    (GetMsgString((MsgEntry*)TypWeightDisplayUnitsTbl, \
                 CWGHCSTD_TYPWEIGHTDISPLAYUNITSTBL_SIZE, \
                 m_structData.m_WeightDisplayUnits))

#define CWGHCSTD_EXTERNALPORT_STRING \
    (GetMsgString((MsgEntry*)TypExternalPortTbl, \
                 CWGHCSTD_TYPEXTERNALPORTTBL_SIZE, \
                 m_structData.m_ExternalPort))

#define CWGHCSTD_SPECIES_STRING \
    (GetMsgString((MsgEntry*)TypSpeciesTbl, \
                 CWGHCSTD_TYPSPECIESTBL_SIZE, \
                 species()))

    /*CWeightCStd Member's Version Enumerations*/
    typedef  enum CWGHCSTDtypVERSIONS {
        CWGHCSTD_Enabled,
        CWGHCSTD_ManualWeight,
        CWGHCSTD_WeightDisplayUnits,
        CWGHCSTD_WeightDefault,
        CWGHCSTD_ExternalPort,
        CWGHCSTD_MEMBER_MAX
    } CWGHCSTD_VERSIONS;

#define CWGHCSTD_VERSION_STATUS(MemberEnum) \
    (GetVersionStatus((VersionEntry*)TypVersionsTbl, \
                      CWGHCSTD_MEMBER_MAX, \
                      MemberEnum))

/*---------------------------------
End...
---------------------------------*/
#ifndef CWEIGHTCSTD_DLLAPI
    #if defined(_MOIB_EXPORT_DLLAPI_)
        #define CWEIGHTCSTD_DLLAPI  __declspec(dllexport)
    #elif defined(_MOIB_IMPORT_DLLAPI_)
        #define CWEIGHTCSTD_DLLAPI  __declspec(dllimport)
    #else
        #define CWEIGHTCSTD_DLLAPI
    #endif
#endif

class CWEIGHTCSTD_DLLAPI CWeightCStd : public DtData
{
public:
    CWeightCStd();
    ~CWeightCStd();

    /*---------------------------------
    CWeightCStd Functions:
    ---------------------------------*/
    boolean GetEnabled();
    void SetEnabled(boolean new_Enabled);

    boolean GetManualWeight();
    void SetManualWeight(boolean new_ManualWeight);

    uint16 GetWeightDisplayUnits();
    void SetWeightDisplayUnits(uint16 new_WeightDisplayUnits);

    uint32 GetWeightDefault();
    void SetWeightDefault(uint32 new_WeightDefault);

    uint16 GetExternalPort();
    void SetExternalPort(uint16 new_ExternalPort);

    void Reset(boolean bResetAll);

    void SetObjectProperties(CWeightCStd *MyObjectSrc);
    /*--------------------------------*/

    /*---------------------------------
       Inherited/Overidden functions:
       Functions derived from DtData
    ---------------------------------*/
    uint16 getVersion (void);

#if((TARGET_XML_SUPPORT == XML_SERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    uint32 serialize_to_XMLbuf(char* pBuf);
#endif
    /*---------------------------------*/

/*---------------------------------------------------
 Use the following struct for classes that will hold
     internal data.
---------------------------------------------------*/
    typedef struct ClassStruct_s{
        /*Static Data*/
            boolean       m_Enabled; /* True if enabled */
            boolean       m_ManualWeight; /* True if enabled */
            uint16        m_WeightDisplayUnits; /* lbs or kg */
            uint32        m_WeightDefault; /* Value presented to user on a new record 1 - 226kg in grams */
            uint16        m_ExternalPort; /* Device port for external weight scale */
    }ClassStruct_t;

#define CWGHCSTD_STATIC_STRUCT_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 2 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))

protected:

    /*---------------------------------
    Enumeration related tables.
    ---------------------------------*/
    static const MsgEntry    TypWeightDisplayUnitsTbl[];
    static const MsgEntry    TypExternalPortTbl[];
    static const MsgEntry     TypSpeciesTbl[];
    static const VersionEntry TypVersionsTbl[];
/*---------------------------------------------------*/
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    uint32 get_payload_size(void);
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);

private:

#if((TARGET_XML_SUPPORT == XML_DESERIALIZE)||(TARGET_XML_SUPPORT == XML_ALL))
    void    parse_StartElement(void *UserData, const XML_Char *Name, const XML_Char **Atts);
    void    parse_CharacterData(void *UserData, const XML_Char *sTag, int Len);
#endif

    void deserialize_static_data(uint8QManager *QMgr, uint16 StructSize);
    void serialize_static_data(uint8QManager * QMgr);

    /*---------------------------------*/

    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/

    ClassStruct_t        m_structData;
};
#endif /* #if !defined(CWEIGHTCSTD_H) */

/*---------------------------------------------------*/
/* End of File */
