/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataObjSvr.h                                                     //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP                                           //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#if !defined(CDATAOBJSVR_H)
    #define  CDATAOBJSVR_H

#include "CObjSvr.h"
#include "CMsgSvr.h"
#include "CTrapObjSvr.h"
#include "CLinkTable.h"

class CDataObjSvr : public CObjSvr
{
private:
    CMsgSvr             MsgSvrIn;
    CMsgSvr             MsgSvrOut;

    CTrapObjSvr*        pTrapServer;

    DataFuncPtr         pMessageHandler;
    SendPacketFuncPtr   pSendMsg;

    char*               pSemName;
    CLinkTable*         pCLinkTable;

public:
    CDataObjSvr();
    ~CDataObjSvr();

    void Init(CTrapObjSvr *pTrapObjSvr,
              boolean (*SendPacket)(char*, char*, uint8*, uint32),
              uint32 (*RxMessage)(char*, uint32, uint8*, void*),
              LinkStruct *pLinkStruct);

    boolean TxMsg(char *pSourceID, CMsgSvr *pMsgSvr, uint16 Family, uint8 Genus, 
                  uint8 Species, uint8* Payload,uint32 Size, boolean bEncryptionOn);
    boolean RecvMsgHandler(char *pSourceID, uint8 *pBuffer, void *pRouter);
    boolean SendMsgHandler(char *pSourceID, uint16 Family, uint8 Genus, uint8 Species, 
                           uint8 *pBuffer, uint32 Size, boolean bEncryptionOn);

};
#endif /* #if !defined(CDATAOBJSVR_H) */

/*---------------------------------------------------*/
/* End of File */
