/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CMsgSvr.h      :                                                  //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOMP Standard Library                          //
'**  '///////////////////////////////////////////////////////////////////////
'*-E************************************************************************/

#if !defined(CMSGSVR_H)
    #define  CMSGSVR_H
#include "DtData.h"
#include "Common.h"

#if defined(ENCRYPTION_ON)
#include "CEncryption.h"
#endif

/*The following definition is the version.*/
#define CMSG_OBJECT_VERSION 100

typedef  enum CMSGtypSPECIES {
    CMSG_SpNONE = 0,
    CMSG_SpMAX
}CMSG_SPECIES;

/*---------------------------------
End...
---------------------------------*/
class CMsgSvr : public DtData
{
public:
    CMsgSvr();
    virtual ~CMsgSvr();

    /*---------------------------------
    Functions:
    Add function prototypes here
    ---------------------------------*/
    void Init(uint16 Family, uint8 Genus, LinkStruct *pLinkStruct);
    void SetData(uint8* new_Data, uint32 Size);
    uint8* GetData(uint32 *size);

#if defined(ENCRYPTION_ON)
    void SetEncryption(char *pSource, boolean bEncryptFlag);
#endif

    virtual boolean is_Extended(uint8* pBuffer);
    virtual boolean is_Extended(uint32 ClassID);
    //---------------------------------------------------
protected:
    /*---------------------------------
     Inherited/Overidden functions:
     Functions derived from DtData
    ---------------------------------*/
    virtual uint32  get_payload_size(void );
    boolean serialize_payload(uint8QManager * QMgr);
    boolean deserialize_payload(uint8QManager * QMgr, uint32 Sz);


    /*--------------------------------------------------
     The following data members relate to the struct
     defined above - if used
    --------------------------------------------------*/
    /*Dynamic Data*/
    uint8       *Data;
    uint32      DataSize;
    
    /* Reference to the Encrytion Object */
#if defined(ENCRYPTION_ON)
    CEncryption Crypt;
    char        *pSourceID;
    boolean     bEncryptionOn;
#endif

    LinkStruct *pLnkStruct;
};
#endif /* #if !defined(CMSGSVR_H) */

/*---------------------------------------------------*/
/* End of File */




