/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFmFILESYSStub.cpp                                                //
'**  '// Language       :   C++                                            //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'**
'*-E************************************************************************/

#include "CWACPApp.h"
#include "CFmFILESYSStub.h"

CFmFILESYSStub::CFmFILESYSStub(CFamilyStub *StubClass)
{
    pStubClass = StubClass;
}

CFmFILESYSStub::~CFmFILESYSStub()
{
}

/*================================================================================
Entry point from CWACPApp to run the process
================================================================================*/
uint16 CFmFILESYSStub::AppInit(char *pSourceID)
{
    int      Result = 0;
#if defined(PC)
    uint32   TestID = 1;
    uint32   CmdRqst = 0;

    while (TestID != 0)
    {
        SYS_PRINTF("\n******************************\n");
        SYS_PRINTF("   FmFILESYS Test\n");
        SYS_PRINTF("******************************\n");
        SYS_PRINTF("0. Exit\n");
        SYS_PRINTF("1. Send Request\n");
        SYS_PRINTF("2. Send Status\n");
        SYS_PRINTF("3. Send Command\n");
        SYS_PRINTF("4. Send Event\n");
        SYS_PRINTF("5. Send DataObj\n");
        SYS_PRINTF("6. Send Stream\n");
        SYS_PRINTF("7. Stress Test\n");
        SYS_PRINTF("8. Monitor Test\n");
        SYS_PRINTF("9. Send All Test\n");
        SYS_PRINTF("Enter selection: ");

        Result = (uint16)scanf("%d", &TestID);
        if(Result == 1)
        {
            if(TestID == 0)
            {
                break;
            }
            else if(TestID == 1)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. GET_FILE\n");
                SYS_PRINTF("\t2. GET_FILE_COUNT\n");
                SYS_PRINTF("\t3. GET_FILE_LIST\n");
                SYS_PRINTF("\nEnter Request ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Request Menu.\n\n");
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 3))
                    {
                        /* Send a request for the associated value */
                        pStubClass->SendMsg(pSourceID, FmFILESYS, GnREQUEST, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 2)
            {
                SYS_PRINTF("\nFmFILESYS Contains No Status Messages\n");
            }
            else if(TestID == 3)
            {
                SYS_PRINTF("\t0. Exit\n");
                SYS_PRINTF("\t1. FILESYS_CCMD_SpWRITE_FILE\n");
                SYS_PRINTF("\nEnter Command ID: ");

                Result = (uint16)scanf("%d", &CmdRqst);
                if(Result == 1)
                {
                    if(CmdRqst == 0)
                    {
                        SYS_PRINTF("\n\nExit Command Menu.\n\n");
                        break;
                    }
                    else if((CmdRqst >= 1) && (CmdRqst <= 1))
                    {
                        pStubClass->SendMsg(pSourceID, FmFILESYS, GnCOMMAND, (uint8)--CmdRqst, NULL, 0, FALSE);
                    }
                    else
                    {
                        SYS_PRINTF("\n\nInvalid Selection.\n\n");
                    }
                }
                else
                {
                    SYS_PRINTF("\n\nInvalid Selection.\n\n");
                }
            }
            else if(TestID == 4)
            {
                SYS_PRINTF("\nFmFILESYS Contains No Events\n");
            }
            else if(TestID == 5)
            {
                SYS_PRINTF("\nFmFILESYS Contains No Data Objects\n");
            }
            else if(TestID == 6)
            {
                SYS_PRINTF("\nFmFILESYS Contains No Streams\n");
            }
            else if(TestID == 7)
            {
                StressTest(pSourceID);
            }
            else if(TestID == 8)
            {
                TxTest(pSourceID);
            }
            else if(TestID == 9)
            {
                SendAllTest(pSourceID);
            }
            else
            {
                SYS_PRINTF("\n\nInvalid Selection.\n\n");
            }
        }
        else
        {
            SYS_PRINTF("\n\nInvalid Selection.\n\n");
        }
        /* Wait a bit before displaying the menu */
        SYS_SLEEP(250);
    }/* while (TestID != 0) */
#else
    TOUCH(pSourceID);
#endif  /* #if defined(PC) */

    return (uint16)Result;
}

/*================================================================================
TxTest
================================================================================*/
void CFmFILESYSStub::TxTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nMonitor Test %d\n", i);

        /* Test only valid response messages */
        pStubClass->RecvMessage(pSourceID, MakeClassID(FmFILESYS, GnREQUEST, (uint8)(i%3)), NULL);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
StressTest : 
================================================================================*/
void CFmFILESYSStub::StressTest(char *pSourceID)
{
#if defined(PC)
    int  MsgCount;
    int  Delay;

    SYS_PRINTF("\nEnter # of messages to send: ");
    scanf("%d", &MsgCount);

    SYS_PRINTF("\nEnter Delay between messages (ms): ");
    scanf("%d", &Delay);

    for(int i = 0; i < MsgCount; i++)
    {
        SYS_PRINTF("\nStress Test %d\n", i);
        pStubClass->SendMsg(pSourceID, FmFILESYS, GnREQUEST, (uint8)(i%3), NULL, 0, FALSE);

        /* Wait the specified amount of time */
        SYS_SLEEP(Delay);
    }
#else
    TOUCH(pSourceID);
#endif
}

/*================================================================================
SendAllTest :
================================================================================*/
void CFmFILESYSStub::SendAllTest(char *pSourceID)
{
#if defined(PC)
    uint8   CmdID = 0;
    uint8   NumCommand = 1;
    uint8   RqstID = 0;
    uint8   NumRequest = 3;

    /* Send all requests */
    for(RqstID = 0; RqstID < NumRequest; RqstID++)
        pStubClass->SendMsg(pSourceID, FmFILESYS, GnREQUEST, RqstID, NULL, 0, FALSE);

    /* Send all commands */
    for(CmdID = 0; CmdID < NumCommand; CmdID++)
        pStubClass->SendMsg(pSourceID, FmFILESYS, GnCOMMAND, CmdID, NULL, 0, FALSE);

#else
    TOUCH(pSourceID);
#endif /* #if defined(PC) */
}
/* End of File */
