/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataTransferCDesc.c                                              //
'**  '// Version        :   2.01                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CDataTransferCDesc.h"

#define CDTACDSC_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CDataTransferCDesc_TypVersionsTbl, \
                      CDTACDSC_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CDataTransferCDesc_TypVersionsTbl[CDTACDSC_MEMBER_MAX] = {
    200, 201, /*CDATATRANSFERCDESC_InitSeqNumber*/
    200, 201, /*CDATATRANSFERCDESC_TotalDataSize*/
    200, 201, /*CDATATRANSFERCDESC_DataPacketSize*/
    200, 201, /*CDATATRANSFERCDESC_Role*/
    200, 201, /*CDATATRANSFERCDESC_Identifier*/
    200, 201, /*CDATATRANSFERCDESC_Descriptor*/
    201, 201, /*CDATATRANSFERCDESC_WindowSize*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CDataTransferCDesc_Init(CDataTransferCDesc *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CDataTransferCDesc));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmDATATRANSFER, GnCONFIG, CDTACDSC_SpDESCRIPTION);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CDataTransferCDesc_Reset(CDataTransferCDesc *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Record Container(s)*/
        CDataTransferCDesc_DeleteDescriptor(pObject);

        /*Initialize the Object*/
        if(bInit)
        {
            CDataTransferCDesc_Init(pObject);
        }
    }
}

/*********************************************************************************
Initializes the container. Deletes any existing items in the container. The argument
Size will used as the max size limit of the container. A size of zero will be used 
to signify that there is no max size limit.
**********************************************************************************/
boolean CDataTransferCDesc_InitDescriptor(CDataTransferCDesc *pObject, uint32 Size)
{
    boolean Result = FALSE;

    if(pObject != NULL)
    {
        /*Delete existing container and
        initialize container's members*/
        Result = CDataTransferCDesc_DeleteDescriptor(pObject);

        if((Result) && (Size))
        {
            /*Allocate memory for the container*/
            pObject->m_Descriptor = (uint8*)SYS_REALLOC(pObject->m_Descriptor, Size * sizeof(uint8));

            if(pObject->m_Descriptor != NULL)
                pObject->m_DescriptorMaxSize = Size * sizeof(uint8); /*Size in bytes*/

            pObject->bDescriptorMaxSize = TRUE;
        }
    }

    return Result;
}
/*********************************************************************************
Appends an item to the containter. If the max size is specified, then pBuffer 
will be appended only if it doesn't exceed the max size. If no max size is 
specified, then the pBuffer is appended without limit checks. NumberElements
is used to specify number of elements that are in pBuffer.
*********************************************************************************/
boolean CDataTransferCDesc_AppendDescriptor(CDataTransferCDesc *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements)
{
    boolean Result = FALSE;

    if((pObject != NULL) && (pBuffer != NULL) &&
       (Size > 0) && (NumberElements > 0))
    {
        if(pObject->bDescriptorMaxSize)
        {
            /*Verify that the Size + Current Size is within the max size limit*/
            if (Size + pObject->m_DescriptorSize <= pObject->m_DescriptorMaxSize)
            {
                /*Copy pBuffer*/
                memcpy(&pObject->m_Descriptor[pObject->m_DescriptorSize], pBuffer, Size);

                /*Calculate new Size*/
                pObject->m_DescriptorSize = pObject->m_DescriptorSize + Size;

                /*Increment number of elements*/
                pObject->m_DescriptorElements = pObject->m_DescriptorElements + NumberElements;

                Result = TRUE;
            }
        }
        /*Append pBuffer without restrictions*/
        else
        {
            pObject->m_Descriptor = (uint8*)SYS_REALLOC(pObject->m_Descriptor, pObject->m_DescriptorSize + Size);

            if(pObject->m_Descriptor != NULL)
            {
                /*Copy pBuffer*/
                memcpy(&pObject->m_Descriptor[pObject->m_DescriptorSize], pBuffer, Size);

                /*Calculate Size*/
                pObject->m_DescriptorSize += Size;

                /*Increment number of elements*/
                pObject->m_DescriptorElements = pObject->m_DescriptorElements + NumberElements;

                Result = TRUE;
            }
        }
    }

    return Result;
}
/*********************************************************************************
Free existing container and initialize to NULL. Initializes container's members.
*********************************************************************************/
boolean CDataTransferCDesc_DeleteDescriptor(CDataTransferCDesc *pObject)
{
    boolean Result = FALSE;

    if(pObject != NULL)
    {
        SYS_FREE(pObject->m_Descriptor);
        pObject->m_Descriptor = NULL;
        pObject->m_DescriptorMaxSize = 0;
        pObject->m_DescriptorSize = 0;
        pObject->m_DescriptorElements = 0;
        pObject->bDescriptorMaxSize = FALSE;

        Result = TRUE;
    }

    return Result;
}
/*********************************************************************************
Return pointer to serialized object at Index
*********************************************************************************/
uint8* CDataTransferCDesc_GetDescriptorAt(CDataTransferCDesc *pObject, uint16 Index, uint32 *pSize)
{
    if((pObject != NULL) && (pSize != NULL))
    {
        if((pObject->m_Descriptor != NULL) && (Index <= pObject->m_DescriptorElements))
        {
            uint8  pTempSize = 0;
            uint8* pBuffer = pObject->m_Descriptor;
            unsigned int i = 0;

            for(i = 0; i < pObject->m_DescriptorElements; i++)
            {
                /*Get size of serialized object*/
                *pSize = MOIBSerialSize(pBuffer, &pTempSize);

                if(i == Index)
                    return pBuffer;
                else
                   /*Increment pBuffer*/
                   pBuffer += *pSize;
            }
        }
    }

        return NULL;
}
/*********************************************************************************
Return pointer to the container
*********************************************************************************/
uint8* CDataTransferCDesc_GetDescriptor(CDataTransferCDesc *pObject, uint32 *pSize)
{
    if((pObject != NULL) && (pSize != NULL))
    {
        if(pObject->m_Descriptor != NULL)
        {
            *pSize = pObject->m_DescriptorSize;
            return pObject->m_Descriptor;
        }
    }

    return NULL;
}
/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CDataTransferCDesc_SizeAll(const CDataTransferCDesc *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CDTACDSC_STATIC_DATA_SIZE;        /*Static data size*/

        /*m_DescriptorElements*/
        Size += sizeof(uint16);

        /*Container Buffer*/
        Size += pObject->m_DescriptorSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CDTACDSC_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CDataTransferCDesc object into the buffer passed in.
*********************************************************************************/
boolean CDataTransferCDesc_Serialize(const CDataTransferCDesc *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        uint32 PayloadSize = CDataTransferCDesc_SizeAll(pObject) - CDTACDSC_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CDTACDSC_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CDTACDSC_STATIC_DATA_SIZE);

        /* Set the m_InitSeqNumber */
        WriteInt32(&pTemp, (uint32)pObject->m_InitSeqNumber);

        /* Set the m_TotalDataSize */
        WriteInt32(&pTemp, (uint32)pObject->m_TotalDataSize);

        /* Set the m_DataPacketSize */
        WriteInt16(&pTemp, (uint16)pObject->m_DataPacketSize);

        /* Set the m_Role */
        WriteInt8(&pTemp, (uint8)pObject->m_Role);

        /* Set the m_Identifier */
        WriteInt32(&pTemp, (uint32)pObject->m_Identifier);

        /* Set the m_WindowSize */
        WriteInt16(&pTemp, (uint16)pObject->m_WindowSize);

        /* Serialize the m_Descriptor */
        WriteInt16(&pTemp, pObject->m_DescriptorElements);
        if (pObject->m_DescriptorElements > 0)
        {
            memcpy(pTemp, pObject->m_Descriptor, pObject->m_DescriptorSize);
            pTemp += pObject->m_DescriptorSize;
        }

        /* Set the CRC */
        CRCSize = CDataTransferCDesc_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CDataTransferCDesc object passed in.
*********************************************************************************/
boolean CDataTransferCDesc_Deserialize(CDataTransferCDesc *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CDTACDSC_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CDataTransferCDesc_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CDTACDSC_VERSION_STATUS(CDTACDSC_InitSeqNumber, pObject->SrcVersion)))
                        {
                            /* Get the m_InitSeqNumber */
                            pObject->m_InitSeqNumber = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if((StructSize) &&
                           (CDTACDSC_VERSION_STATUS(CDTACDSC_TotalDataSize, pObject->SrcVersion)))
                        {
                            /* Get the m_TotalDataSize */
                            pObject->m_TotalDataSize = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if((StructSize) &&
                           (CDTACDSC_VERSION_STATUS(CDTACDSC_DataPacketSize, pObject->SrcVersion)))
                        {
                            /* Get the m_DataPacketSize */
                            pObject->m_DataPacketSize = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if((StructSize) &&
                           (CDTACDSC_VERSION_STATUS(CDTACDSC_Role, pObject->SrcVersion)))
                        {
                            /* Get the m_Role */
                            pObject->m_Role = ReadInt8(&pTemp);
                            ElementsUsed -= sizeof(uint8);
                            StructSize -= sizeof(uint8);
                        }
                        if((StructSize) &&
                           (CDTACDSC_VERSION_STATUS(CDTACDSC_Identifier, pObject->SrcVersion)))
                        {
                            /* Get the m_Identifier */
                            pObject->m_Identifier = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if((StructSize) &&
                           (CDTACDSC_VERSION_STATUS(CDTACDSC_WindowSize, pObject->SrcVersion)))
                        {
                            /* Get the m_WindowSize */
                            pObject->m_WindowSize = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                        if((CDTACDSC_VERSION_STATUS(CDTACDSC_Descriptor, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            uint16 TempElements = 0;
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_DescriptorElements */
                                TempElements = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                if (TempElements > 0)
                                {
                                    uint8 pSize = 0;
                                    uint8* pBuffer = NULL; 
                                    uint32 TempSize = 0;
                                    unsigned i = 0;

                                    pBuffer = pTemp;

                                    /* Calculate the m_Descriptor size */
                                    for(i = 0; i < TempElements; i++)
                                    {
                                        /*Extract the serialized object's size*/
                                        TempSize = MOIBSerialSize(pBuffer, &pSize);

                                        /*Increment pBuffer*/
                                        pBuffer += TempSize;

                                        /*Increment the max size*/
                                        pObject->m_DescriptorMaxSize += TempSize;
                                    }

                                    if(ElementsUsed > pObject->m_DescriptorMaxSize)
                                    {
                                        /*Initialize the container with new max size*/
                                        if(CDataTransferCDesc_InitDescriptor(pObject, pObject->m_DescriptorMaxSize))
                                        {
                                            /*Append entire container*/
                                            if(CDataTransferCDesc_AppendDescriptor(pObject, pTemp, pObject->m_DescriptorMaxSize, TempElements))
                                            {
                                                pTemp += pObject->m_DescriptorMaxSize;
                                                ElementsUsed = ElementsUsed - pObject->m_DescriptorMaxSize;
                                                bResult = TRUE;
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    /*The record member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CDataTransferCDesc_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

