/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDataTransferDExtStd.h                                            //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CDATATRANSFERDEXTSTD_H)
    #define  CDATATRANSFERDEXTSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDTADXSTDtypSPECIES {
        CDTADXSTD_SpSTANDARD = 0, 
        CDTADXSTD_SpMAX
    } CDTADXSTD_SPECIES;

    /*CDataTransferDExtStd Member's Version Enumerations*/
    typedef  enum CDTADXSTDtypVERSIONS {
        CDTADXSTD_SeqNumber,
        CDTADXSTD_Identifier,
        CDTADXSTD_Data,
        CDTADXSTD_MEMBER_MAX
    } CDTADXSTD_VERSIONS;


/*The following definition is the version.*/
#define CDTADXSTD_OBJECT_VERSION 200

#define CDTADXSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CDTADXSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 2 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CDataTransferDExtStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_SeqNumber; /* Sequence Number/byte offset of current packet sent or the next requested. The sequence number is 1 based. A value of 0 indicates that it is not specified. */
    uint32             m_Identifier; /* Used to identify the Data Transfer */

    /*Dynamic Data*/
    uint8              *m_Data; /*Generic byte array that contains data*/
    uint16    m_DataSize;

}CDataTransferDExtStd;

void    CDataTransferDExtStd_Init(CDataTransferDExtStd *pObject);
void    CDataTransferDExtStd_Reset(CDataTransferDExtStd *pObject, boolean bResetAll, boolean bInit);
uint32  CDataTransferDExtStd_SizeAll(const CDataTransferDExtStd *pObject);
boolean CDataTransferDExtStd_Deserialize(CDataTransferDExtStd *pObject, uint8 *pBuf);
boolean CDataTransferDExtStd_Serialize(const CDataTransferDExtStd *pObject, uint8 *pBuf);

#endif /* #if !defined(CDATATRANSFERDEXTSTD_H) */

