/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDevDPOST.c                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CDevDPOST.h"

#define CDEVDPST_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CDevDPOST_TypVersionsTbl, \
                      CDEVDPST_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CDevDPOST_TypVersionsTbl[CDEVDPST_MEMBER_MAX] = {
    100, 200, /*CDEVDPOST_DeviceGUID*/
    100, 200, /*CDEVDPOST_SourceID*/
    200, 200, /*CDEVDPOST_POSTStatus*/
    200, 200, /*CDEVDPOST_ErrorList*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CDevDPOST_Init(CDevDPOST *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CDevDPOST));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmDEVICE, GnDATA, CDEVDPST_SpPOST);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CDevDPOST_Reset(CDevDPOST *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Dynamic members*/
        SYS_FREE(pObject->m_SourceID);
        pObject->m_SourceID = NULL;
        pObject->m_SourceIDSize = 0;


        /*Reset Record Container(s)*/
        CDevDPOST_DeleteErrorList(pObject);

        /*Initialize the Object*/
        if(bInit)
        {
            CDevDPOST_Init(pObject);
        }
    }
}

/*********************************************************************************
Initializes the container. Deletes any existing items in the container. The argument
Size will used as the max size limit of the container. A size of zero will be used 
to signify that there is no max size limit.
**********************************************************************************/
boolean CDevDPOST_InitErrorList(CDevDPOST *pObject, uint32 Size)
{
    boolean Result = FALSE;

    if(pObject != NULL)
    {
        /*Delete existing container and
        initialize container's members*/
        Result = CDevDPOST_DeleteErrorList(pObject);

        if((Result) && (Size))
        {
            /*Allocate memory for the container*/
            pObject->m_ErrorList = (uint8*)SYS_REALLOC(pObject->m_ErrorList, Size * sizeof(uint8));

            if(pObject->m_ErrorList != NULL)
                pObject->m_ErrorListMaxSize = Size * sizeof(uint8); /*Size in bytes*/

            pObject->bErrorListMaxSize = TRUE;
        }
    }

    return Result;
}
/*********************************************************************************
Appends an item to the containter. If the max size is specified, then pBuffer 
will be appended only if it doesn't exceed the max size. If no max size is 
specified, then the pBuffer is appended without limit checks. NumberElements
is used to specify number of elements that are in pBuffer.
*********************************************************************************/
boolean CDevDPOST_AppendErrorList(CDevDPOST *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements)
{
    boolean Result = FALSE;

    if((pObject != NULL) && (pBuffer != NULL) &&
       (Size > 0) && (NumberElements > 0))
    {
        if(pObject->bErrorListMaxSize)
        {
            /*Verify that the Size + Current Size is within the max size limit*/
            if (Size + pObject->m_ErrorListSize <= pObject->m_ErrorListMaxSize)
            {
                /*Copy pBuffer*/
                memcpy(&pObject->m_ErrorList[pObject->m_ErrorListSize], pBuffer, Size);

                /*Calculate new Size*/
                pObject->m_ErrorListSize = pObject->m_ErrorListSize + Size;

                /*Increment number of elements*/
                pObject->m_ErrorListElements = pObject->m_ErrorListElements + NumberElements;

                Result = TRUE;
            }
        }
        /*Append pBuffer without restrictions*/
        else
        {
            pObject->m_ErrorList = (uint8*)SYS_REALLOC(pObject->m_ErrorList, pObject->m_ErrorListSize + Size);

            if(pObject->m_ErrorList != NULL)
            {
                /*Copy pBuffer*/
                memcpy(&pObject->m_ErrorList[pObject->m_ErrorListSize], pBuffer, Size);

                /*Calculate Size*/
                pObject->m_ErrorListSize += Size;

                /*Increment number of elements*/
                pObject->m_ErrorListElements = pObject->m_ErrorListElements + NumberElements;

                Result = TRUE;
            }
        }
    }

    return Result;
}
/*********************************************************************************
Free existing container and initialize to NULL. Initializes container's members.
*********************************************************************************/
boolean CDevDPOST_DeleteErrorList(CDevDPOST *pObject)
{
    boolean Result = FALSE;

    if(pObject != NULL)
    {
        SYS_FREE(pObject->m_ErrorList);
        pObject->m_ErrorList = NULL;
        pObject->m_ErrorListMaxSize = 0;
        pObject->m_ErrorListSize = 0;
        pObject->m_ErrorListElements = 0;
        pObject->bErrorListMaxSize = FALSE;

        Result = TRUE;
    }

    return Result;
}
/*********************************************************************************
Return pointer to serialized object at Index
*********************************************************************************/
uint8* CDevDPOST_GetErrorListAt(CDevDPOST *pObject, uint16 Index, uint32 *pSize)
{
    if((pObject != NULL) && (pSize != NULL))
    {
        if((pObject->m_ErrorList != NULL) && (Index <= pObject->m_ErrorListElements))
        {
            uint8  pTempSize = 0;
            uint8* pBuffer = pObject->m_ErrorList;
            unsigned int i = 0;

            for(i = 0; i < pObject->m_ErrorListElements; i++)
            {
                /*Get size of serialized object*/
                *pSize = MOIBSerialSize(pBuffer, &pTempSize);

                if(i == Index)
                    return pBuffer;
                else
                   /*Increment pBuffer*/
                   pBuffer += *pSize;
            }
        }
    }

        return NULL;
}
/*********************************************************************************
Return pointer to the container
*********************************************************************************/
uint8* CDevDPOST_GetErrorList(CDevDPOST *pObject, uint32 *pSize)
{
    if((pObject != NULL) && (pSize != NULL))
    {
        if(pObject->m_ErrorList != NULL)
        {
            *pSize = pObject->m_ErrorListSize;
            return pObject->m_ErrorList;
        }
    }

    return NULL;
}
/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CDevDPOST_SizeAll(const CDevDPOST *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CDEVDPST_STATIC_DATA_SIZE;        /*Static data size*/

        /*m_ErrorListElements*/
        Size += sizeof(uint16);

        /*Container Buffer*/
        Size += pObject->m_ErrorListSize;

        Size += sizeof(uint16) + pObject->m_SourceIDSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CDEVDPST_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CDevDPOST object into the buffer passed in.
*********************************************************************************/
boolean CDevDPOST_Serialize(const CDevDPOST *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CDevDPOST_SizeAll(pObject) - CDEVDPST_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CDEVDPST_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CDEVDPST_STATIC_DATA_SIZE);

        /* Set the m_DeviceGUID */
        for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_DeviceGUID[index]); 
        }

        /* Set the m_POSTStatus */
        WriteInt32(&pTemp, (uint32)pObject->m_POSTStatus);

        /* Set the m_SourceIDSize */
        WriteInt16(&pTemp, pObject->m_SourceIDSize);

        /* Set the m_SourceID */
        for(index = 0; index < (pObject->m_SourceIDSize/sizeof(ansichar)); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_SourceID[index]); 
        }

        /* Serialize the m_ErrorList */
        WriteInt16(&pTemp, pObject->m_ErrorListElements);
        if (pObject->m_ErrorListElements > 0)
        {
            memcpy(pTemp, pObject->m_ErrorList, pObject->m_ErrorListSize);
            pTemp += pObject->m_ErrorListSize;
        }

        /* Set the CRC */
        CRCSize = CDevDPOST_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CDevDPOST object passed in.
*********************************************************************************/
boolean CDevDPOST_Deserialize(CDevDPOST *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;
            uint32  index;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CDEVDPST_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CDevDPOST_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CDEVDPST_VERSION_STATUS(CDEVDPST_DeviceGUID, pObject->SrcVersion)))
                        {
                            /* Get the m_DeviceGUID */
                            for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
                            {
                                pObject->m_DeviceGUID[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_DeviceGUID);
                            StructSize -= sizeof(pObject->m_DeviceGUID);
                        }
                        if((StructSize) &&
                           (CDEVDPST_VERSION_STATUS(CDEVDPST_POSTStatus, pObject->SrcVersion)))
                        {
                            /* Get the m_POSTStatus */
                            pObject->m_POSTStatus = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                        if((CDEVDPST_VERSION_STATUS(CDEVDPST_SourceID, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_SourceIDSize */
                                pObject->m_SourceIDSize = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                /* Get the m_SourceID */
                                if (pObject->m_SourceIDSize > 0)
                                {
                                    if(ElementsUsed > pObject->m_SourceIDSize)
                                    {
                                        pObject->m_SourceID = (ansichar*)SYS_REALLOC(pObject->m_SourceID, pObject->m_SourceIDSize);
                                        if(pObject->m_SourceID != NULL)
                                        {
                                            for(index = 0; index < pObject->m_SourceIDSize/sizeof(ansichar); index++)
                                            {
                                                pObject->m_SourceID[index] = ReadInt8(&pTemp);
                                            }
                                            ElementsUsed = ElementsUsed - pObject->m_SourceIDSize;
                                            bResult = TRUE;
                                        }
                                    }
                                }
                                else
                                {
                                    /*The dynamic member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                        if((CDEVDPST_VERSION_STATUS(CDEVDPST_ErrorList, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            uint16 TempElements = 0;
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_ErrorListElements */
                                TempElements = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                if (TempElements > 0)
                                {
                                    uint8 pSize = 0;
                                    uint8* pBuffer = NULL; 
                                    uint32 TempSize = 0;
                                    unsigned i = 0;

                                    pBuffer = pTemp;

                                    /* Calculate the m_ErrorList size */
                                    for(i = 0; i < TempElements; i++)
                                    {
                                        /*Extract the serialized object's size*/
                                        TempSize = MOIBSerialSize(pBuffer, &pSize);

                                        /*Increment pBuffer*/
                                        pBuffer += TempSize;

                                        /*Increment the max size*/
                                        pObject->m_ErrorListMaxSize += TempSize;
                                    }

                                    if(ElementsUsed > pObject->m_ErrorListMaxSize)
                                    {
                                        /*Initialize the container with new max size*/
                                        if(CDevDPOST_InitErrorList(pObject, pObject->m_ErrorListMaxSize))
                                        {
                                            /*Append entire container*/
                                            if(CDevDPOST_AppendErrorList(pObject, pTemp, pObject->m_ErrorListMaxSize, TempElements))
                                            {
                                                pTemp += pObject->m_ErrorListMaxSize;
                                                ElementsUsed = ElementsUsed - pObject->m_ErrorListMaxSize;
                                                bResult = TRUE;
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    /*The record member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CDevDPOST_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

