/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDevDPOST.h                                                       //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CDEVDPOST_H)
    #define  CDEVDPOST_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVDPSTtypPOSTSTATUS {
        CDEVDPST_POSTStatus_NONE = 0, /*NONE*/
        CDEVDPST_POSTStatus_IN_PROGRESS = 1, /*POST In Progress*/
        CDEVDPST_POSTStatus_COMPLETE = 2, /*POST Complete Successfully*/
        CDEVDPST_POSTStatus_FAILURE = 3, /*POST Failure*/
        CDEVDPST_POSTStatus_MAX
    } CDEVDPST_POSTSTATUS;

    typedef  enum CDEVDPSTtypSPECIES {
        CDEVDPST_SpPOST = 3, 
        CDEVDPST_SpMAX
    } CDEVDPST_SPECIES;

    /*CDevDPOST Member's Version Enumerations*/
    typedef  enum CDEVDPSTtypVERSIONS {
        CDEVDPST_DeviceGUID,
        CDEVDPST_SourceID,
        CDEVDPST_POSTStatus,
        CDEVDPST_ErrorList,
        CDEVDPST_MEMBER_MAX
    } CDEVDPST_VERSIONS;


/*The following definition is the version.*/
#define CDEVDPST_OBJECT_VERSION 200

#define CDEVDPST_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CDEVDPST_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 16 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CDevDPOST
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint8              m_DeviceGUID[16]; /* Contains the GUID of the Device */
    uint32             m_POSTStatus; /* Indicates the POST status */

    /*Dynamic Data*/
    ansichar           *m_SourceID; /*Contains the SourceID of the Device*/
    uint16    m_SourceIDSize;

    /*Record Data*/
    uint8    *m_ErrorList;
    uint32   m_ErrorListSize;
    uint32   m_ErrorListMaxSize;
    uint16   m_ErrorListElements;
    boolean  bErrorListMaxSize;

}CDevDPOST;

void    CDevDPOST_Init(CDevDPOST *pObject);
void    CDevDPOST_Reset(CDevDPOST *pObject, boolean bResetAll, boolean bInit);
uint32  CDevDPOST_SizeAll(const CDevDPOST *pObject);
boolean CDevDPOST_Deserialize(CDevDPOST *pObject, uint8 *pBuf);
boolean CDevDPOST_Serialize(const CDevDPOST *pObject, uint8 *pBuf);

boolean  CDevDPOST_InitErrorList(CDevDPOST *pObject, uint32 Size);
boolean  CDevDPOST_AppendErrorList(CDevDPOST *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements);
boolean  CDevDPOST_DeleteErrorList(CDevDPOST *pObject);
uint8*   CDevDPOST_GetErrorListAt(CDevDPOST *pObject, uint16 Index, uint32 *pSize);
uint8*   CDevDPOST_GetErrorList(CDevDPOST *pObject, uint32 *pSize);

#endif /* #if !defined(CDEVDPOST_H) */

