/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDExtStd.h                                                  //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CDEVICEDEXTSTD_H)
    #define  CDEVICEDEXTSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CDEVDXTSTDtypSPECIES {
        CDEVDXTSTD_SpSTANDARD = 0, 
        CDEVDXTSTD_SpMAX
    } CDEVDXTSTD_SPECIES;

    /*CDeviceDExtStd Member's Version Enumerations*/
    typedef  enum CDEVDXTSTDtypVERSIONS {
        CDEVDXTSTD_DeviceContainer,
        CDEVDXTSTD_MEMBER_MAX
    } CDEVDXTSTD_VERSIONS;


/*The following definition is the version.*/
#define CDEVDXTSTD_OBJECT_VERSION 200

#define CDEVDXTSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CDEVDXTSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CDeviceDExtStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Record Data*/
    uint8    *m_DeviceContainer;
    uint32   m_DeviceContainerSize;
    uint32   m_DeviceContainerMaxSize;
    uint16   m_DeviceContainerElements;
    boolean  bDeviceContainerMaxSize;

}CDeviceDExtStd;

void    CDeviceDExtStd_Init(CDeviceDExtStd *pObject);
void    CDeviceDExtStd_Reset(CDeviceDExtStd *pObject, boolean bResetAll, boolean bInit);
uint32  CDeviceDExtStd_SizeAll(const CDeviceDExtStd *pObject);
boolean CDeviceDExtStd_Deserialize(CDeviceDExtStd *pObject, uint8 *pBuf);
boolean CDeviceDExtStd_Serialize(const CDeviceDExtStd *pObject, uint8 *pBuf);

boolean  CDeviceDExtStd_InitDeviceContainer(CDeviceDExtStd *pObject, uint32 Size);
boolean  CDeviceDExtStd_AppendDeviceContainer(CDeviceDExtStd *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements);
boolean  CDeviceDExtStd_DeleteDeviceContainer(CDeviceDExtStd *pObject);
uint8*   CDeviceDExtStd_GetDeviceContainerAt(CDeviceDExtStd *pObject, uint16 Index, uint32 *pSize);
uint8*   CDeviceDExtStd_GetDeviceContainer(CDeviceDExtStd *pObject, uint32 *pSize);

#endif /* #if !defined(CDEVICEDEXTSTD_H) */

