/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CDeviceDStd.c                                                     //
'**  '// Version        :   1.02                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CDeviceDStd.h"

#define CDEVDSTD_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CDeviceDStd_TypVersionsTbl, \
                      CDEVDSTD_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CDeviceDStd_TypVersionsTbl[CDEVDSTD_MEMBER_MAX] = {
    100, 102, /*CDEVICEDSTD_DateTime*/
    100, 102, /*CDEVICEDSTD_RunTime*/
    100, 102, /*CDEVICEDSTD_ModelName*/
    100, 102, /*CDEVICEDSTD_SerialNumber*/
    100, 102, /*CDEVICEDSTD_DeviceGUID*/
    101, 102, /*CDEVICEDSTD_ModelNumber*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CDeviceDStd_Init(CDeviceDStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CDeviceDStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmDEVICE, GnDATA, CDEVDSTD_SpSTANDARD);

        /*Set the DeviceGUID*/
        memcpy(pObject->m_DeviceGUID, DeviceGUID, sizeof(pObject->m_DeviceGUID));
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CDeviceDStd_Reset(CDeviceDStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Initialize the Object*/
        if(bInit)
        {
            CDeviceDStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CDeviceDStd_SizeAll(const CDeviceDStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CDEVDSTD_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16);            /* CRC bytes */

        return CDEVDSTD_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CDeviceDStd object into the buffer passed in.
*********************************************************************************/
boolean CDeviceDStd_Serialize(const CDeviceDStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CDeviceDStd_SizeAll(pObject) - CDEVDSTD_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CDEVDSTD_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CDEVDSTD_STATIC_DATA_SIZE);

        /* Set the m_DateTime */
        Put_MOIBTIME(&pTemp, pObject->m_DateTime);

        /* Set the m_RunTime */
        WriteInt32(&pTemp, (uint32)pObject->m_RunTime);

        /* Set the m_ModelName */
        for(index = 0; index < sizeof(pObject->m_ModelName)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_ModelName[index]); 
        }

        /* Set the m_SerialNumber */
        for(index = 0; index < sizeof(pObject->m_SerialNumber)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_SerialNumber[index]); 
        }

        /* Set the m_DeviceGUID */
        for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_DeviceGUID[index]); 
        }

        /* Set the m_ModelNumber */
        for(index = 0; index < sizeof(pObject->m_ModelNumber)/sizeof(ansichar); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_ModelNumber[index]); 
        }

        /* Set the CRC */
        CRCSize = CDeviceDStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CDeviceDStd object passed in.
*********************************************************************************/
boolean CDeviceDStd_Deserialize(CDeviceDStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;
            uint32  index;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CDEVDSTD_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CDeviceDStd_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CDEVDSTD_VERSION_STATUS(CDEVDSTD_DateTime, pObject->SrcVersion)))
                        {
                            /* Get the m_DateTime */
                            pObject->m_DateTime = Get_MOIBTIME(&pTemp);
                            ElementsUsed -= MOIB_TIME_SIZE;
                            StructSize -= MOIB_TIME_SIZE;
                        }
                        if((StructSize) &&
                           (CDEVDSTD_VERSION_STATUS(CDEVDSTD_RunTime, pObject->SrcVersion)))
                        {
                            /* Get the m_RunTime */
                            pObject->m_RunTime = ReadInt32(&pTemp);
                            ElementsUsed -= sizeof(uint32);
                            StructSize -= sizeof(uint32);
                        }
                        if((StructSize) &&
                           (CDEVDSTD_VERSION_STATUS(CDEVDSTD_ModelName, pObject->SrcVersion)))
                        {
                            /* Get the m_ModelName */
                            for(index = 0; index < sizeof(pObject->m_ModelName)/sizeof(ansichar); index++)
                            {
                                pObject->m_ModelName[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_ModelName);
                            StructSize -= sizeof(pObject->m_ModelName);
                        }
                        if((StructSize) &&
                           (CDEVDSTD_VERSION_STATUS(CDEVDSTD_SerialNumber, pObject->SrcVersion)))
                        {
                            /* Get the m_SerialNumber */
                            for(index = 0; index < sizeof(pObject->m_SerialNumber)/sizeof(ansichar); index++)
                            {
                                pObject->m_SerialNumber[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_SerialNumber);
                            StructSize -= sizeof(pObject->m_SerialNumber);
                        }
                        if((StructSize) &&
                           (CDEVDSTD_VERSION_STATUS(CDEVDSTD_DeviceGUID, pObject->SrcVersion)))
                        {
                            /* Get the m_DeviceGUID */
                            for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
                            {
                                pObject->m_DeviceGUID[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_DeviceGUID);
                            StructSize -= sizeof(pObject->m_DeviceGUID);
                        }
                        if((StructSize) &&
                           (CDEVDSTD_VERSION_STATUS(CDEVDSTD_ModelNumber, pObject->SrcVersion)))
                        {
                            /* Get the m_ModelNumber */
                            for(index = 0; index < sizeof(pObject->m_ModelNumber)/sizeof(ansichar); index++)
                            {
                                pObject->m_ModelNumber[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_ModelNumber);
                            StructSize -= sizeof(pObject->m_ModelNumber);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CDeviceDStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

