/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFileSysPSelector.c                                               //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CFileSysPSelector.h"

#define CFSYDPSEL_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CFileSysPSelector_TypVersionsTbl, \
                      CFSYDPSEL_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CFileSysPSelector_TypVersionsTbl[CFSYDPSEL_MEMBER_MAX] = {
    200, 200, /*CFILESYSPSELECTOR_PathName*/
    200, 200, /*CFILESYSPSELECTOR_StartIndex*/
    200, 200, /*CFILESYSPSELECTOR_EndIndex*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CFileSysPSelector_Init(CFileSysPSelector *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CFileSysPSelector));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmFILESYS, GnPARAMETER, CFSYDPSEL_SpSELECTOR);
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CFileSysPSelector_Reset(CFileSysPSelector *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Dynamic members*/
        SYS_FREE(pObject->m_PathName);
        pObject->m_PathName = NULL;
        pObject->m_PathNameSize = 0;


        /*Initialize the Object*/
        if(bInit)
        {
            CFileSysPSelector_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CFileSysPSelector_SizeAll(const CFileSysPSelector *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CFSYDPSEL_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16) + pObject->m_PathNameSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CFSYDPSEL_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CFileSysPSelector object into the buffer passed in.
*********************************************************************************/
boolean CFileSysPSelector_Serialize(const CFileSysPSelector *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CFileSysPSelector_SizeAll(pObject) - CFSYDPSEL_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CFSYDPSEL_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CFSYDPSEL_STATIC_DATA_SIZE);

        /* Set the m_StartIndex */
        WriteInt16(&pTemp, (uint16)pObject->m_StartIndex);

        /* Set the m_EndIndex */
        WriteInt16(&pTemp, (uint16)pObject->m_EndIndex);

        /* Set the m_PathNameSize */
        WriteInt16(&pTemp, pObject->m_PathNameSize);

        /* Set the m_PathName */
        for(index = 0; index < (pObject->m_PathNameSize/sizeof(widechar)); index++)
        {
            WriteInt16(&pTemp, (uint16)pObject->m_PathName[index]); 
        }

        /* Set the CRC */
        CRCSize = CFileSysPSelector_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CFileSysPSelector object passed in.
*********************************************************************************/
boolean CFileSysPSelector_Deserialize(CFileSysPSelector *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;
            uint32  index;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CFSYDPSEL_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CFileSysPSelector_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CFSYDPSEL_VERSION_STATUS(CFSYDPSEL_StartIndex, pObject->SrcVersion)))
                        {
                            /* Get the m_StartIndex */
                            pObject->m_StartIndex = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if((StructSize) &&
                           (CFSYDPSEL_VERSION_STATUS(CFSYDPSEL_EndIndex, pObject->SrcVersion)))
                        {
                            /* Get the m_EndIndex */
                            pObject->m_EndIndex = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                        if((CFSYDPSEL_VERSION_STATUS(CFSYDPSEL_PathName, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_PathNameSize */
                                pObject->m_PathNameSize = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                /* Get the m_PathName */
                                if (pObject->m_PathNameSize > 0)
                                {
                                    if(ElementsUsed > pObject->m_PathNameSize)
                                    {
                                        pObject->m_PathName = (widechar*)SYS_REALLOC(pObject->m_PathName, pObject->m_PathNameSize);
                                        if(pObject->m_PathName != NULL)
                                        {
                                            /* Dequeue the dynamic array with the proper endianness according to the object version */
                                            if(Version < 200)
                                            {
                                                memcpy(pObject->m_PathName, pTemp, (size_t)pObject->m_PathNameSize);
                                                pTemp += pObject->m_PathNameSize;
                                            }
                                            else
                                            {
                                                for(index = 0; index < pObject->m_PathNameSize/sizeof(widechar); index++)
                                                {
                                                    pObject->m_PathName[index] = ReadInt16(&pTemp);
                                                }
                                            }
                                            ElementsUsed = ElementsUsed - pObject->m_PathNameSize;
                                            bResult = TRUE;
                                        }
                                    }
                                }
                                else
                                {
                                    /*The dynamic member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CFileSysPSelector_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

