/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFileSysPSelector.h                                               //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CFILESYSPSELECTOR_H)
    #define  CFILESYSPSELECTOR_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CFSYDPSELtypSPECIES {
        CFSYDPSEL_SpSELECTOR = 1, 
        CFSYDPSEL_SpMAX
    } CFSYDPSEL_SPECIES;

    /*CFileSysPSelector Member's Version Enumerations*/
    typedef  enum CFSYDPSELtypVERSIONS {
        CFSYDPSEL_PathName,
        CFSYDPSEL_StartIndex,
        CFSYDPSEL_EndIndex,
        CFSYDPSEL_MEMBER_MAX
    } CFSYDPSEL_VERSIONS;


/*The following definition is the version.*/
#define CFSYDPSEL_OBJECT_VERSION 200

#define CFSYDPSEL_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CFSYDPSEL_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 2 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CFileSysPSelector
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint16             m_StartIndex; /* The starting index of the files requested. Only applicable in the GET_FILE_LIST request. The index is 1 based. A value of 0 indicates that it is not specified. */
    uint16             m_EndIndex; /* The ending index of the files requested. Only applicable in the GET_FILE_LIST request. The index is 1 based. A value of 0 indicates that it is not specified. */

    /*Dynamic Data*/
    widechar           *m_PathName; /*The PathName is the path to a folder or file. The path must start with a '\'. A trailing slash is ignored.*/
    uint16    m_PathNameSize;

}CFileSysPSelector;

void    CFileSysPSelector_Init(CFileSysPSelector *pObject);
void    CFileSysPSelector_Reset(CFileSysPSelector *pObject, boolean bResetAll, boolean bInit);
uint32  CFileSysPSelector_SizeAll(const CFileSysPSelector *pObject);
boolean CFileSysPSelector_Deserialize(CFileSysPSelector *pObject, uint8 *pBuf);
boolean CFileSysPSelector_Serialize(const CFileSysPSelector *pObject, uint8 *pBuf);

#endif /* #if !defined(CFILESYSPSELECTOR_H) */

