/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CFlashDChunk.h                                                    //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CFLASHDCHUNK_H)
    #define  CFLASHDCHUNK_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CFLSDCHKtypSPECIES {
        CFLSDCHK_SpFLASHCHK = 1, 
        CFLSDCHK_SpMAX
    } CFLSDCHK_SPECIES;

    /*CFlashDChunk Member's Version Enumerations*/
    typedef  enum CFLSDCHKtypVERSIONS {
        CFLSDCHK_OffSet,
        CFLSDCHK_Data,
        CFLSDCHK_MEMBER_MAX
    } CFLSDCHK_VERSIONS;


/*The following definition is the version.*/
#define CFLSDCHK_OBJECT_VERSION 200

#define CFLSDCHK_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CFLSDCHK_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 1 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CFlashDChunk
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    uint32             m_OffSet; /* Indicates the byte offset. The first chunk of data will have a byte offset of zero. */

    /*Dynamic Data*/
    uint8              *m_Data; /*Contains the image data chunk*/
    uint16    m_DataSize;

}CFlashDChunk;

void    CFlashDChunk_Init(CFlashDChunk *pObject);
void    CFlashDChunk_Reset(CFlashDChunk *pObject, boolean bResetAll, boolean bInit);
uint32  CFlashDChunk_SizeAll(const CFlashDChunk *pObject);
boolean CFlashDChunk_Deserialize(CFlashDChunk *pObject, uint8 *pBuf);
boolean CFlashDChunk_Serialize(const CFlashDChunk *pObject, uint8 *pBuf);

#endif /* #if !defined(CFLASHDCHUNK_H) */

