/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CModuleDExtStd.h                                                  //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CMODULEDEXTSTD_H)
    #define  CMODULEDEXTSTD_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CMODDXTSTDtypSPECIES {
        CMODDXTSTD_SpSTANDARD = 0, /*Indicates that this is an object describing the Finished Medical Device.*/
        CMODDXTSTD_SpHOST = 1, /*Indicates that this is an object describing a host (Compute Engine) subsystem.*/
        CMODDXTSTD_SpSENSOR = 2, /*Indicates that this is an object describing a sensor subsystem.*/
        CMODDXTSTD_SpMAX
    } CMODDXTSTD_SPECIES;

    /*CModuleDExtStd Member's Version Enumerations*/
    typedef  enum CMODDXTSTDtypVERSIONS {
        CMODDXTSTD_ModuleContainer,
        CMODDXTSTD_MEMBER_MAX
    } CMODDXTSTD_VERSIONS;


/*The following definition is the version.*/
#define CMODDXTSTD_OBJECT_VERSION 200

#define CMODDXTSTD_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CMODDXTSTD_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 0 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 0 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CModuleDExtStd
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Record Data*/
    uint8    *m_ModuleContainer;
    uint32   m_ModuleContainerSize;
    uint32   m_ModuleContainerMaxSize;
    uint16   m_ModuleContainerElements;
    boolean  bModuleContainerMaxSize;

}CModuleDExtStd;

void    CModuleDExtStd_Init(CModuleDExtStd *pObject);
void    CModuleDExtStd_Reset(CModuleDExtStd *pObject, boolean bResetAll, boolean bInit);
uint32  CModuleDExtStd_SizeAll(const CModuleDExtStd *pObject);
boolean CModuleDExtStd_Deserialize(CModuleDExtStd *pObject, uint8 *pBuf);
boolean CModuleDExtStd_Serialize(const CModuleDExtStd *pObject, uint8 *pBuf);

boolean  CModuleDExtStd_InitModuleContainer(CModuleDExtStd *pObject, uint32 Size);
boolean  CModuleDExtStd_AppendModuleContainer(CModuleDExtStd *pObject, uint8 *pBuffer, uint32 Size, uint16 NumberElements);
boolean  CModuleDExtStd_DeleteModuleContainer(CModuleDExtStd *pObject);
uint8*   CModuleDExtStd_GetModuleContainerAt(CModuleDExtStd *pObject, uint16 Index, uint32 *pSize);
uint8*   CModuleDExtStd_GetModuleContainer(CModuleDExtStd *pObject, uint32 *pSize);

#endif /* #if !defined(CMODULEDEXTSTD_H) */

