/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CNumDFloat.h                                                      //
'**  '// Version        :   2.00                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#if !defined(CNUMDFLOAT_H)
    #define  CNUMDFLOAT_H

#if defined(WIN32)
#include <stdio.h>
#include <string.h>
#endif

#include "StdVarTyp.h"
#include "target.h"
#include "DtSupport.h"
#include "DtData.h"
#include "Mem.h"

/*---------------------------------
Add Defines for string representation
of enumerations in the next section.
---------------------------------*/
    typedef  enum CNUMDFLTtypSTATUSBITS {
        CNUMDFLT_StatusBits_ValidRange = 0, /*sensor specified.*/
        CNUMDFLT_StatusBits_OverRange = 1, /*+++, sensor specified.*/
        CNUMDFLT_StatusBits_UnderRange = 2, /*---, sensor specified.*/
        CNUMDFLT_StatusBits_UndeterminedRange = 3, /*???, sensor specified.*/
        CNUMDFLT_StatusBits_NoAlarm = 4, 
        CNUMDFLT_StatusBits_UpperLimitAlarm = 5, 
        CNUMDFLT_StatusBits_LowerLimitAlarm = 6, 
        CNUMDFLT_StatusBits_OtherAlarm = 7, 
        CNUMDFLT_StatusBits_NumericActive = 8, /*This field is de-asserted if: the channel is not zeroed, the channel is uncallibrated, or the channel is searching*/
        CNUMDFLT_StatusBits_Continuous = 9, 
        CNUMDFLT_StatusBits_SpotOld = 10, 
        CNUMDFLT_StatusBits_SpotRecent = 11, 
        CNUMDFLT_StatusBits_SpotNew = 12, 
        CNUMDFLT_StatusBits_Dubious = 13, /*Sensor specified. Suspect reading such as splat for SAO*/
        CNUMDFLT_StatusBits_MAX
    } CNUMDFLT_STATUSBITS;

    typedef  enum CNUMDFLTtypSPECIES {
        CNUMDFLT_SpFLOAT = 31, 
        CNUMDFLT_SpMAX
    } CNUMDFLT_SPECIES;

    /*CNumDFloat Member's Version Enumerations*/
    typedef  enum CNUMDFLTtypVERSIONS {
        CNUMDFLT_Value,
        CNUMDFLT_StatusBits,
        CNUMDFLT_MEMBER_MAX
    } CNUMDFLT_VERSIONS;


/*The following definition is the version.*/
#define CNUMDFLT_OBJECT_VERSION 200

#define CNUMDFLT_MOIB_HEADER_SIZE(ClassID)\
    (sizeof(uint32) + (IsExtended_ClassID(ClassID) ? sizeof(uint32) : sizeof(uint16)))

#define CNUMDFLT_STATIC_DATA_SIZE\
               (0 * MOIB_TIME_SIZE        + 0 *(sizeof(int8))\
                   + 0 *(sizeof(int16))   + 0 *(sizeof(int32))\
                   + 0 *(sizeof(uint8))   + 1 *(sizeof(uint16))\
                   + 0 *(sizeof(uint32))  + 0 *(sizeof(byte))\
                   + 0 *(sizeof(word))    + 0 *(sizeof(boolean))\
                   + 0 *(sizeof(char))    + 0 *(sizeof(ansichar))\
                   + 0 *(sizeof(widechar))+ 1 *(sizeof(float))\
                   + 0 *(sizeof(double)))


typedef struct CNumDFloat
{
    /* DtData Members */
    uint32      ClassID;
    byte        DataBitField;
    uint16      SrcVersion;

    /*Static Data*/
    float              m_Value; /* float numeric value */
    uint16             m_StatusBits; /* see enumerator */

}CNumDFloat;

void    CNumDFloat_Init(CNumDFloat *pObject);
void    CNumDFloat_Reset(CNumDFloat *pObject, boolean bResetAll, boolean bInit);
uint32  CNumDFloat_SizeAll(const CNumDFloat *pObject);
boolean CNumDFloat_Deserialize(CNumDFloat *pObject, uint8 *pBuf);
boolean CNumDFloat_Serialize(const CNumDFloat *pObject, uint8 *pBuf);

#endif /* #if !defined(CNUMDFLOAT_H) */

