/*-D************************************************************************* 
'*   This program source file is confidential and proprietary property of
'*    Welch Allyn, Inc. Unauthorized use or reproduction is prohibited.
'****************************************************************************
'****************************************************************************
'**
'****************************************************************************
'**  ////////////////////////////////////////////////////////////////////////
'**  '// CRNDZDStd.c                                                       //
'**  '// Version        :   1.01                                           //
'**  '// Language       :   C                                              //
'**  '// Application    :   WACP                                           //
'**  '// Sources        :   MOIB Standard Library                          //
'**  '// AppGen Version :   4.8.0                                          //
'**  '///////////////////////////////////////////////////////////////////////
'****************************************************************************
'**
'**
'****************************************************************************
'****************************************************************************
'** Generated from DDS_Merlion.xml version 22
'*-E************************************************************************/

#include "CRNDZDStd.h"

const uint8 DeviceGUID[16] = {0x7E, 0xC3, 0x19, 0x2C, 0xBE, 0xF9, 0x4e, 0xee, 
                               0xBB, 0xAA, 0x7A, 0x18, 0xC6, 0x94, 0xBB, 0x02};

const uint16 DDSVersion = 22;

#define CRDZDSTD_VERSION_STATUS(MemberEnum, SrcVersion) \
    (GetVersionStatus((VersionEntry*)CRNDZDStd_TypVersionsTbl, \
                      CRDZDSTD_MEMBER_MAX, \
                      MemberEnum, \
                      SrcVersion))

static const VersionEntry CRNDZDStd_TypVersionsTbl[CRDZDSTD_MEMBER_MAX] = {
    100, 101, /*CRNDZDSTD_DeviceGUID*/
    101, 101, /*CRNDZDSTD_DDSVersion*/
    101, 101, /*CRNDZDSTD_Data*/
};

/*********************************************************************************
Initializes the structure and creates a default class ID
*********************************************************************************/
void CRNDZDStd_Init(CRNDZDStd *pObject)
{
    if(pObject != NULL)
    {
        /*Initialize the structure*/
        memset(pObject, 0, sizeof(CRNDZDStd));

        /*Set the class ID*/
        pObject->ClassID = (uint32)MakeClassID(FmRENDEZVOUS, GnDATA, CRDZDSTD_SpSTANDARD);

        /*Set the DeviceGUID*/
        memcpy(pObject->m_DeviceGUID, DeviceGUID, sizeof(pObject->m_DeviceGUID));

        /*Set the DDSVersion*/
        pObject->m_DDSVersion = DDSVersion;
    }
}
/*********************************************************************************
Frees any members that were allocated. Initializes the structure if bInit is TRUE.
*********************************************************************************/
void CRNDZDStd_Reset(CRNDZDStd *pObject, boolean bResetAll, boolean bInit)
{
    TOUCH(bResetAll);

    if(pObject != NULL)
    {
        /*Reset Dynamic members*/
        SYS_FREE(pObject->m_Data);
        pObject->m_Data = NULL;
        pObject->m_DataSize = 0;


        /*Initialize the Object*/
        if(bInit)
        {
            CRNDZDStd_Init(pObject);
        }
    }
}

/*********************************************************************************
Returns the total number of bytes required to serialize the data.
*********************************************************************************/
uint32 CRNDZDStd_SizeAll(const CRNDZDStd *pObject)
{
    uint32 Size = 0;

    if (pObject != NULL)
    {
        Size = sizeof(uint16)                /*Object Version*/
             + sizeof(boolean)                   /*is dirty flag*/
             + sizeof(uint16)                    /*Size of the struct*/
             + CRDZDSTD_STATIC_DATA_SIZE;        /*Static data size*/

        Size += sizeof(uint16) + pObject->m_DataSize;

        Size += sizeof(uint16);            /* CRC bytes */

        return CRDZDSTD_MOIB_HEADER_SIZE(pObject->ClassID) + Size;
    }
    else
        return Size;
}

/*********************************************************************************
Serializes the contents of the CRNDZDStd object into the buffer passed in.
*********************************************************************************/
boolean CRNDZDStd_Serialize(const CRNDZDStd *pObject, uint8 *pBuf)
{
    boolean Result = TRUE;
    uint8 *pTemp = pBuf;

    if ((pObject != NULL) && (pTemp != NULL))
    {
        uint32 CRCSize;
        unsigned int index;
        uint32 PayloadSize = CRNDZDStd_SizeAll(pObject) - CRDZDSTD_MOIB_HEADER_SIZE(pObject->ClassID);

        /* Set the classID */
        WriteInt32(&pTemp, pObject->ClassID);

        /* Set the payload size */
        if(IsExtended_ClassID(pObject->ClassID))
            WriteInt32(&pTemp, PayloadSize);
        else
            WriteInt16(&pTemp, (uint16)PayloadSize);

        /* Set the version */
        WriteInt16(&pTemp, (uint16)CRDZDSTD_OBJECT_VERSION);

        /* Set the Data Byte */
        WriteInt8(&pTemp, pObject->DataBitField);

        /* Set the static struct size */
        WriteInt16(&pTemp, (uint16)CRDZDSTD_STATIC_DATA_SIZE);

        /* Set the m_DeviceGUID */
        for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_DeviceGUID[index]); 
        }

        /* Set the m_DDSVersion */
        WriteInt16(&pTemp, (uint16)pObject->m_DDSVersion);

        /* Set the m_DataSize */
        WriteInt16(&pTemp, pObject->m_DataSize);

        /* Set the m_Data */
        for(index = 0; index < (pObject->m_DataSize/sizeof(uint8)); index++)
        {
            WriteInt8(&pTemp, (uint8)pObject->m_Data[index]); 
        }

        /* Set the CRC */
        CRCSize = CRNDZDStd_SizeAll(pObject) - sizeof(uint16);
        WriteInt16(&pTemp, CalculateCRC(CRC_SEED, pBuf, CRCSize));
    }
    else
        Result = FALSE;

    return Result; 
}

/*********************************************************************************
Deserializes the contents of the buffer into the CRNDZDStd object passed in.
*********************************************************************************/
boolean CRNDZDStd_Deserialize(CRNDZDStd *pObject, uint8 *pBuf)
{
    uint8 *pTemp = pBuf;
    boolean bResult = FALSE;

    if (pObject != NULL)
    {
        if(pTemp != NULL)
        {
            uint16  Version;
            uint16  StructSize;
            uint32  ElementsUsed;
            uint16  StoredCRC;
            uint16  CalcCRC;
            uint32  CRCSize;
            uint32  ClassID;
            uint32  index;

            /* Calculate the CRC */
            CRCSize = GetCRCSize(pBuf) - sizeof(uint16);
            CalcCRC = CalculateCRC(CRC_SEED, pBuf, CRCSize);

            /* Get the stored CRC */
            StoredCRC = ReadInt16Ext(&pTemp[CRCSize]);

            /* Check the CRC */
            if (CalcCRC == StoredCRC)
            {
                /* Verify the Family and Genus match */
                ClassID = ReadInt32(&pTemp);
                if ((ClassID & 0xFFFFFF00) == (pObject->ClassID & 0xFFFFFF00))
                {
                    /* Get the size of the payload */
                    if(IsExtended_ClassID(ClassID))
                        ElementsUsed = ReadInt32(&pTemp);
                    else
                        ElementsUsed = ReadInt16(&pTemp);

                    /* Get the Version */
                    Version = ReadInt16(&pTemp);
                    ElementsUsed -= sizeof(uint16);

                    if(Version <= CRDZDSTD_OBJECT_VERSION)
                    {
                        bResult = TRUE;

                        /*Reset the object*/
                        CRNDZDStd_Reset(pObject, TRUE, TRUE);

                        /* Set the ClassID to update the species */
                        pObject->ClassID = ClassID;

                        /* Store the dequeued version */
                        pObject->SrcVersion = Version;

                        /* Get the DataBitField */
                        SetDataBitField(&pObject->DataBitField, ReadInt8(&pTemp));
                        ElementsUsed -= sizeof(uint8);

                        /* Get the size of the static structure */
                        StructSize = ReadInt16(&pTemp);
                        ElementsUsed -= sizeof(uint16);

                        if((StructSize) &&
                           (CRDZDSTD_VERSION_STATUS(CRDZDSTD_DeviceGUID, pObject->SrcVersion)))
                        {
                            /* Get the m_DeviceGUID */
                            for(index = 0; index < sizeof(pObject->m_DeviceGUID)/sizeof(uint8); index++)
                            {
                                pObject->m_DeviceGUID[index] = ReadInt8(&pTemp);
                            }
                            ElementsUsed -= sizeof(pObject->m_DeviceGUID);
                            StructSize -= sizeof(pObject->m_DeviceGUID);
                        }
                        if((StructSize) &&
                           (CRDZDSTD_VERSION_STATUS(CRDZDSTD_DDSVersion, pObject->SrcVersion)))
                        {
                            /* Get the m_DDSVersion */
                            pObject->m_DDSVersion = ReadInt16(&pTemp);
                            ElementsUsed -= sizeof(uint16);
                            StructSize -= sizeof(uint16);
                        }
                        if(StructSize)
                        {
                            /* Dequeue the remaining extra bytes of the static struct */
                            pTemp += StructSize;
                            ElementsUsed = ElementsUsed - StructSize;
                        }

                        if((CRDZDSTD_VERSION_STATUS(CRDZDSTD_Data, pObject->SrcVersion)) &&
                           (bResult))
                        {
                            bResult = FALSE;

                            if(ElementsUsed > sizeof(uint16))
                            {
                                /* Get the m_DataSize */
                                pObject->m_DataSize = ReadInt16(&pTemp);
                                ElementsUsed -= sizeof(uint16);

                                /* Get the m_Data */
                                if (pObject->m_DataSize > 0)
                                {
                                    if(ElementsUsed > pObject->m_DataSize)
                                    {
                                        pObject->m_Data = (uint8*)SYS_REALLOC(pObject->m_Data, pObject->m_DataSize);
                                        if(pObject->m_Data != NULL)
                                        {
                                            for(index = 0; index < pObject->m_DataSize/sizeof(uint8); index++)
                                            {
                                                pObject->m_Data[index] = ReadInt8(&pTemp);
                                            }
                                            ElementsUsed = ElementsUsed - pObject->m_DataSize;
                                            bResult = TRUE;
                                        }
                                    }
                                }
                                else
                                {
                                    /*The dynamic member has a size of zero*/
                                    bResult = TRUE;
                                }
                            }
                        }

                    }
                }
            }
        }

        if (bResult == FALSE)
        {
            /*Reset the object*/
            CRNDZDStd_Reset(pObject, TRUE, TRUE);
        }
    }

    return bResult;
}

